#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AutoIt Version: 3.3.12
Author: Richard Wiener
Home:http://richard.wiener.sweb.cz/moje/SW/index.htm

Script Multiple clipboard

Ctrl-v, Ctrl-x - Store clipboard into buffer
Ctrl-v - Retrieve buffer into clipboard.
         Hold Ctrl = press v or x list repeatelly throw buffer
                     press x to delete item from buffer or take no action

#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#pragma compile(ProductName, "RClipStep")
#pragma compile(ProductVersion, 6.07.007)
#pragma compile(FileVersion, 6.7.7)
#pragma compile(CompanyName, 'Richard Wiener')
#pragma compile(LegalCopyright, "Richard Wiener")
#pragma compile(FileDescription, 'Clipboard manager for handling clipboard')


#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Script Start - Option, declaration of variables, tray menu, starting program
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         
Opt("MustDeclareVars",1)

#Include <Array.au3>
#Include <Constants.au3>
#Include <Clipboard.au3>
#Include <Crypt.au3>
#include <EditConstants.au3>
#include <GDIPlus.au3>
#include <GuiButton.au3>
#include <GUIConstantsEx.au3>
#include <GuiEdit.au3>
#include <GuiImageList.au3>
#include <GuiListView.au3>
#include <GuiStatusBar.au3>
#Include <Misc.au3>
#Include <ScreenCapture.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

;default values could be replaced by rclipstep.ini
; Variable for limit of arrays
Global $LimitList = 10000
Global $cliplist[$LimitList+1][6]
; 0 = text clip
; 1 = Clip name 
; 2 = Indicator for finding clips 
; 3 = Date of modification
; 4 = Attribut R=Read Only, F=Free position, I=Include (clips from include dir), H=Hidden, O = Hidden & Read Only (Include)
; 5 = item number for show_clip
; Array for sorting heapsort (value, index) 
Global $Heap[$LimitList+1][2]
Global $HeapLimit = 0
; Lenght for show ToolTip for first use in ms 
Global $ShowTime = 330    ;delay for some action, f.e. showtip 0 means no Tooltip window (near mouse cursor)
Global $StoreTime = 50    ;delay between press Ctrl-C and send Ctrl-c into application
; Lenght clips for showing it in tooltip (preview window)
Global $ShowLen = 200
Global $IncompProg[10000]
Global $IncompProgType[10000]
Global $IncompProgAction[10000]
Global $IncompProgLimit
; curclip - current clip in clipboard, showclip - clip in buffet, that could be inserted into clipboard instead of curclip
; in normal state, this two clips are same
Global $DirName, $InitDirName, $curclip, $maxclip
Global $maxcurclip ; variable for shifting clips during ctrl_v, current maximum clips is maxclip
Global $showclip = 0, $numclip
Global $ClearBuff ,$DirExists, $aboutitem, $inititem, $exititem, $showitem
Global $cleardir, $refresh, $stopdir, $massdelete, $showcopy, $showcopy_y
Global $maxmsg, $maxabout, $store_clip, $storeitem
Global $ChangeDir, $ManageDir, $MoveClip, $IncludeDir, $BeepDuration, $BeepFrequency
Global $ClipHandler = 0, $ClipNext = 0, $ToolHeight, $ToolWidth, $dll, $hbitmap
Global $StoreBitmap, $showGUI
Const $IdentBitmap = " -- Bitmap format clipboard ", $IdentBinary=" -- Binary format clipboard --"
Global $NameClip
Global $iQuality
Global $IsVReleased = 0
Global $IsCReleased = 0
Global $IsXReleased = 0
Global $ReWriteClip, $FindClip
; Variable $RegisteringClipboard indicate if clipboard could be registered after some action (delete clip) or not (action has been called from Ctrl-V, registering clipboard is unwanted)
Global $RegisteringClipboard = 1 
Global $RestartView = 0
Global $BmpExt = ".png" 
Global $is_setv = 0
Global $is_preview = 0 
Global $is_control = 0
Global $ImageHeight = 300, $ImageWidth = 400, $BitmapEditor="", $TextEditor=""
Global $hWnd_setv, $LineHeight, $PageLines, $dblclck_diff, $SUPasteDelay, $ButtonFictive, $hWnd2 = 0
Global $DebugFile, $DebugScreen, $DebugProg, $ExitKey, $AutoDestroyPreview 
Global $BgColorNormal, $BgColorInsert, $itemno, $closeClipboard = 0
Global $AllowDuplicity, $AutoClearQueue, $ClearQueue
; global buttons for preview clips
Global $ButtonEdit, $ButtonName, $ButtonMove, $ButtonDelete, $ButtonFind, $PreClip, $Button1Delete, $ButtonRO, $ButtonH
Global $InitSort, $pre_item = -1



Opt("TrayMenuMode",1)   ; Default tray menu items (Script Paused/Exit) will not be shown.
Opt("SendKeyDelay", 0)  ; Default = 5 
Opt("MouseCoordMode",2) ; Default = 1; 2 Means relative coordinates to active windows 
OnAutoItExitRegister("Cleanup")


$InitDirName = "Clips"  ;this cannot be in Init, it will be reset dirname to default if you refresh clips from stored location on disk
If FileExists($InitDirName) = 1 Then
   $DirName = $InitDirName
Else
  $DirName = ""
EndIf

Init()

If $DirName == "NoSaveClips" Then
   $InitDirName = ""
   $DirName = ""
ElseIf $InitDirName <> $DirName Then
   $DirName = $InitDirName
   StopDir()
EndIf

$stopdir  = TrayCreateItem(show_mess(0,$DirName))
$showitem  = TrayCreateItem(show_mess(1))
$showcopy = TrayCreateItem(show_mess(2)) 
$massdelete  = TrayCreateItem(show_mess(3))
$inititem  = TrayCreateItem(show_mess(4))
$ManageDir  = TrayCreateItem(show_mess(25,$DirName))
$refresh  = TrayCreateItem(show_mess(5))
$ChangeDir  = TrayCreateItem(show_mess(23))
$MoveClip  = TrayCreateItem(show_mess(26))
$storeitem  = TrayCreateItem(show_mess(22))
$NameClip = TrayCreateItem(show_mess(30,""))
$ReWriteClip = TrayCreateItem(show_mess(31,""))
$FindClip = TrayCreateItem(show_mess(34,""))
TrayCreateItem("")
$aboutitem  = TrayCreateItem(show_mess(6))
$exititem   = TrayCreateItem(show_mess(7))
TrayItemSetState($showitem,$TRAY_DEFAULT)
TraySetIcon("ClipStep.ico")
TrayItemSetState($storeitem,$TRAY_CHECKED)            
TraySetState()

If $DirName="" Then
   $DirExists = 0
   TrayItemSetState($stopdir,$TRAY_UNCHECKED)
   TrayItemSetState($refresh,$TRAY_DISABLE)
   TrayItemSetState($ManageDir,$TRAY_DISABLE)
   TrayItemSetState($ChangeDir,$TRAY_DISABLE)
Else
   TrayItemSetState($stopdir,$TRAY_CHECKED)
EndIf  
if $store_clip=0 then
	TrayItemSetState($storeitem,$TRAY_UNCHECKED)
else
	TrayItemSetState($storeitem,$TRAY_CHECKED)
endif

Local $getmsg, $n, $getmsg2

While 1
	If $hWnd2 <> 0 Then
		$getmsg2 = GUIGetMsg()
  	If WinActive ($hWnd2) Then
    	show_list()
  	EndIf
  EndIf
;  debug_write(0,@ScriptLineNumber&" - "&"$currentWindows="&$currentWindows&" $hWnd2="&$hWnd2,"main_script")
  If $RestartView = 1 Then
    show_list()
  EndIf
	$getmsg = TrayGetMsg()
  Switch $getmsg  
  	Case  0
	   	ContinueLoop
    Case  $aboutitem            
			msgbox(4096,default,set_about())
      TrayItemSetState($aboutitem,$TRAY_UNCHECKED)            
    Case  $inititem
     	cleardir()
      TrayItemSetState($inititem,$TRAY_UNCHECKED)            
    Case  $showcopy
      IF TrayItemGetState($showcopy) = $TRAY_CHECKED THEN
       	$showcopy_y = 1
      ELSE
      	$showcopy_y = 0
      ENDIF
      init_viewer()
    Case  $refresh
      Init()
      TrayItemSetState($refresh,$TRAY_UNCHECKED)            
    Case  $massdelete
      massdelete()
      TrayItemSetState($massdelete,$TRAY_UNCHECKED)            
    Case $showitem  
      debug_write(0,@ScriptLineNumber&" - activate show_list "&" $getmsg="&$getmsg &" $showitem="&$showitem,"main script")
      show_list()
			$n = $TRAY_UNCHECKED + $TRAY_DEFAULT
			TrayItemSetState($showitem, $n )
    Case $stopdir
     	stopdir()
    Case $ChangeDir
			NewQueue("")
      TrayItemSetState($ChangeDir,$TRAY_UNCHECKED)
    Case $ManageDir
			Run(@ComSpec & " /c " & 'start "RClipStep" "'&@WorkingDir&"\"&$DirName&'"')
      TrayItemSetState($ManageDir,$TRAY_UNCHECKED)
    Case $MoveClip
      Move_clip()
      TrayItemSetState($MoveClip,$TRAY_UNCHECKED)
    Case $exititem
      ExitLoop
    Case  $storeitem
      if $store_clip=1 then
       	TrayItemSetState($storeitem,$TRAY_UNCHECKED)
				$store_clip=0
      else
       	TrayItemSetState($storeitem,$TRAY_CHECKED)
				$store_clip=1
			endif            
    Case  $NameClip
      Name_Clip()
      TrayItemSetState($NameClip,$TRAY_UNCHECKED)
    Case  $ReWriteClip
      edit_clip()
      TrayItemSetState($ReWriteClip,$TRAY_UNCHECKED)
    Case  $FindClip
      Find_Clip()
      TrayItemSetState($FindClip,$TRAY_UNCHECKED)
  EndSwitch
WEnd
Exit

#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Function for getting clips, handling keys, storing clips into buffer, pasting back
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

; Functions
; Handle $WM_CHANGECBCHAIN messages
Func WM_CHANGECBCHAIN($hWnd, $iMsg, $iwParam, $ilParam)
  $DebugProg="WM_CHANGECBCHAIN"
  debug_write(0,@ScriptLineNumber&" - "&"$ClipNext="&$ClipNext&" $iwParam="&$iwParam&" $ilParam="&$ilParam&" $ClipHandler="&$ClipHandler)
	; If the next window is closing, repair the chain
	If $iwParam = $ClipNext Then
		$ClipNext = $ilParam
	; Otherwise pass the message to the next viewer
	ElseIf $ClipNext <> $ClipHandler Then
		_SendMessage ($ClipNext, $WM_CHANGECBCHAIN, $iwParam, $ilParam)
	EndIf
EndFunc   ;==>WM_CHANGECBCHAIN

; Handle $WM_DRAWCLIPBOARD messages
Func WM_DRAWCLIPBOARD($hWnd, $iMsg, $iwParam, $ilParam)
  ; Pass the message to the next viewer
	If $ClipNext <> 0 Then
  	_SendMessage ($ClipNext, $WM_DRAWCLIPBOARD, $iwParam, $ilParam)
  EndIf
	; Store text from clipboard to rclipstep
  ; Bypass storing clip for Ctrl-Insert
 	debug_write(0,@ScriptLineNumber&" - "&"getdate="&StringLeft(_ClipBoard_GetData($CF_TEXT),60)&" $store_clip="&$store_clip&" $RegisteringClipboard="&$RegisteringClipboard,"WM_DRAWCLIPBOARD")
  If NOT _IsPressed("2D",$dll) And $store_clip = 1 And $RegisteringClipboard = 1 Then
    StoreClipFull()
	EndIf
EndFunc   ;==>WM_DRAWCLIPBOARD

; Main function when Ctrl-v has been pressed
Func setv()
	$DebugProg="setv"
  local $tmp, $i, $Incomp, $WinClass, $tooltext = "", $ControlId
  local $title, $is_forms, $is_cr, $handle, $buff, $IsPressedCount
  $is_setv = 1
  $RegisteringClipboard = 0
  StoreClip(1)
   ; Set for v and c to move up and down throw clips
  $tmp = ""
	set_keys()
	$numclip = 0
  $ClearBuff = 0
  $IsVReleased = 0 ;try to avoid moving clip for initially pressing Ctrl-V
  $IsCReleased = 0 
  $IsXReleased = 0
  ; Main loop - waiting till Ctrl is pressed
  $IsPressedCount = 0
	While _IsPressed("11",$dll) And $is_setv=1
    $IsPressedCount = $IsPressedCount + 1 
    If NOT _IsPressed("56",$dll) Then 
    	$IsVReleased = 1
      debug_write(0,@ScriptLineNumber&" - "&"$IsVReleased= "&$IsVReleased)
    EndIf
    If NOT _IsPressed("43",$dll) Then 
      $IsCReleased = 1
      debug_write(0,@ScriptLineNumber&" - "&"$IsVReleased= "&$IsVReleased)
    EndIf
    If NOT _IsPressed("58",$dll) Then 
      $IsXReleased = 1
      debug_write(0,@ScriptLineNumber&" - "&"$IsVReleased= "&$IsVReleased)
    EndIf
		If $ClearBuff = 0 then
			If $tooltext <> String_tool($showclip, $ShowLen) Then
				$tooltext = String_tool($showclip, $ShowLen)
        	Show_Tool($tooltext,0)
			EndIf
		ElseIf $ClearBuff = 1 Then 
      ; remove current clip
	  	$tmp = String_tool($showclip, $ShowLen)
			If $tooltext <> show_mess(29,$tmp) Then
  			$tooltext = show_mess(29,$tmp)
   			Show_Tool($tooltext,0)
   	  EndIf
		ElseIf $ClearBuff = 2 Then 
			; No action
			If $tooltext <> show_mess(8) Then
      	$tooltext = show_mess(8)            
     		Show_Tool($tooltext,0)
     	EndIf
		ElseIf $ClearBuff = 3 Then
			; Remove all clips
			If $tooltext <> show_mess(4) Then
      	$tooltext = show_mess(4)            
     		Show_Tool($tooltext,0)
     	EndIf
		ElseIf $ClearBuff = 4 Then
			; Change position of current clip 
			If $tooltext <> show_mess(26) Then
      	$tooltext = show_mess(26)            
     		Show_Tool($tooltext,0)
     	EndIf
		ElseIf $ClearBuff = 5 Then
			; Change position of current clip 
			If $tooltext <> show_mess(1) Then
      	$tooltext = show_mess(1)            
     		Show_Tool($tooltext,0)
     	EndIf
    EndIf
	WEnd
; Inserting clip, end of rclipstep mode - start experiments
;   If $IsPressedCount = 0 Then
;      SendKeepActive($hWnd_setv)
;      Send("sssss")
;      debug_write(0,@ScriptLineNumber&" - "&" error="&@error)          
;      ControlSend("","","","eeeeeeeeeeeeeeeeee")
;      debug_write(0,@ScriptLineNumber&" - "&" error="&@error)          
;      Local $sControl = ControlGetFocus("")
;      debug_write(0,@ScriptLineNumber&" - "&"The control that has focus is: " & $sControl & " - title "& $Title)
;      $ControlId = ControlGetHandle ($title,"",ControlGetFocus($title))
;      debug_write(0,@ScriptLineNumber&" - "&"ControlId="&$ControlId&" error="&@error)          
;      $ControlId = ControlGetHandle ("","","")
;      ControlSend($hWnd_setv,"",$ControlId,"eeeeeeeeeeeeeeeeee")
;      debug_write(0,@ScriptLineNumber&" - "&"ControlId s null="&$ControlId&" error="&@error&" gettext:"&ControlGetText("","",$ControlId)&" $hWnd_setv="&$hWnd_setv)          
      ;_SendMessageA($ControlId,$WM_PASTE,0,0)
;      $IsPressedCount = $IsPressedCount+1
;      If $IsPressedCount>3 Then
;         msgbox(4096,default,show_mess(xx))
;         $IsPressedCount = 0
;      Else
;         HotKeySet("^v")
;         Sleep(500)
;      EndIf            
;      $is_setv=0
;      set_keys()
;      Return
;   Else
;      $IsPressedCount = 0
;   EndIf    
;     end of experiments
; Inserting clip, end of rclipstep mode - current work
  If $IsPressedCount = 0 Then
  ; Strange application (maybe another user), no riqht to control - paste clit to such application
  	$is_setv=0
    set_keys()
    HotKeySet("^f", "show_list")
    HotKeySet("^v")
    debug_write(0,@ScriptLineNumber&" - "&"Strange application (maybe another user)")
    Sleep($SUPasteDelay)
    $is_setv=0
    set_keys()
    Return
  EndIf    
  If $is_setv=1 Then
  	$is_setv=0
    If $ClearBuff = 0 Then
    	; If you want to paste another clips then current then use ClipPut
      If  $curclip <> $showclip Then
      	$curclip = $showclip
        If is_bitmap() Then
        	Retrieve_bitmap($curclip)
        Else
        	clip_put2 ($curclip)
        EndIf
      EndIf      
    	; Paste clipboard into application
      ; Special hack for incompatibile programs
		  $hWnd_setv = WinGetHandle("[ACTIVE]", "")
      SendKeepActive($hWnd_setv)
		  $title = StringLower(WinGetTitle($hWnd_setv, ""))
		  $WinClass = StringLower(_WinAPI_GetClassName($hWnd_setv))
		  debug_write(0,@ScriptLineNumber&" - "&"class= "&_WinAPI_GetClassName($hWnd_setv)&" title="&$title)
		  FOR $Incomp = 0 TO $IncompProgLimit-1
		    If StringInStr($IncompProg[$Incomp],"[class:",2)>0 Then
		    	$buff = StringReplace($IncompProg[$Incomp],"[class:","",1,1)
		      $buff = StringReplace($buff,"]","",-1,1)
		      $is_forms = StringCompare($WinClass,$buff,1)
		      debug_write(0,@ScriptLineNumber&" - "&"i= "&$Incomp&" prog="&$buff&" is="&$is_forms&" class="&$WinClass)
		      If $is_forms = 0 Then
		      	$is_forms = 1
		  	    ExitLoop
		      Else
		      	$is_forms = 0
		      EndIf
		    Else
		      $is_forms = StringInStr($title,$IncompProg[$Incomp],1)
		      debug_write(0,@ScriptLineNumber&" - "&"i= "&$Incomp&" prog="&$IncompProg[$Incomp]&" is="&$is_forms&" title="&$title)
		      If $is_forms > 0 Then
		  	  	ExitLoop
		      EndIf
		    EndIf
		  NEXT
      debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip&" showclip="&$showclip&" $ClearBuff="&$ClearBuff&" $IsPressedCount="&$IsPressedCount)
      If $is_forms > 0 Then
      	PasteSpecial($cliplist[$curclip][0], $Incomp, $hWnd_setv)
      Else
      	HotKeySet("^v")
        Sleep($StoreTime)
        Send("^v")
      EndIf
      SendKeepActive("")
    ElseIf $ClearBuff = 1 then
    	;Delete current clip from buffer
      DeleteClip($showclip,$showclip)
    ElseIf $ClearBuff = 2 then
    	;Do nothing
      $ClearBuff = 0
    ElseIf $ClearBuff = 3 then
    	;Delele all clips
      cleardir()		
      $ClearBuff = 0
    ElseIf $ClearBuff = 4 then
     	;Change position of actual clip
      Move_clip()		
      $ClearBuff = 0
    ElseIf $ClearBuff = 5 then
     	;Show preview windows
      $is_setv=0
      show_list()		
      $ClearBuff = 0
    EndIf
	EndIf
  ; Registering viewer is handled by set_keys
  set_keys()
  Show_Tool("",0)
  $numclip = 0
  Tray_tool($showclip)
EndFunc

Func PasteSpecial($clip, $Incomp, $hWnd)
  $DebugProg="PasteSpecial"
  local $i, $len, $line, $sendbuff, $action1, $action2, $action3, $ControlId
  $clip = StringReplace($clip, chr(13)&chr(10), chr(10))
  $clip = StringReplace($clip, chr(10)&chr(13), chr(10))
  $clip = StringReplace($clip,chr(13),chr(10))
  $len = StringLen($clip)
  $line = 0
  debug_write(0,@ScriptLineNumber&" - "&"$Incomp="&$Incomp&" $IncompProgType="&$IncompProgType[$Incomp])
  $action1 = StringMid($IncompProgType[$Incomp],1,1)
  $action2 = StringMid($IncompProgType[$Incomp],2,1)
  $action3 = StringMid($IncompProgType[$Incomp],3,1)
  If $action1= "s" Then
  	 $ControlId = ControlGetHandle ($hWnd,"",ControlGetFocus($hWnd))
    debug_write(0,@ScriptLineNumber&" - "&"ControlId="&$ControlId&" error="&@error)          
    _SendMessageA($ControlId,$WM_PASTE,0,0)
    Return
  EndIf
  If $action1= "n" Then
  	HotKeySet("^v")
    Sleep($StoreTime)
    Send("^v")
    Return
  EndIf
	; Show_Tool("PasteSpecial i="&$Incomp)
  ; Loop for ability to break it by press ESC
   While $len>0
      debug_write(0,@ScriptLineNumber&" - "&"Line "&$line)
      If $IncompProgAction[$Incomp]<> "" Then
         If $action1 = "b" OR $action1 = "l" Then
            If $line = 0 Then 
               If ($action2 = "f") OR ($action2 = "a") Then
                  debug_write(0,@ScriptLineNumber&" - "&" Sending "&$IncompProgAction[$Incomp])
                  Send($IncompProgAction[$Incomp])
               EndIf
            elseIf $line = 1 Then
               If ($action2 = "n") OR ($action2 = "a") OR ($action2 = "s") Then
                  debug_write(0,@ScriptLineNumber&" - "&" Sending "&$IncompProgAction[$Incomp])
                  Send($IncompProgAction[$Incomp])
               EndIf         
            else
               If ($action2 = "n") OR ($action2 = "a") Then
                  debug_write(0,@ScriptLineNumber&" - "&"Sending "&$IncompProgAction[$Incomp])
                  Send($IncompProgAction[$Incomp])
               EndIf
            EndIf
         EndIf
      EndIf
      $i = StringInStr($clip,chr(10))
      If $i = 0 Then
         $sendbuff = $clip
      Else
         $sendbuff = StringLeft($clip,$i-1)
      EndIf		
      If $action3 = 'u' Then
         $sendbuff = $sendbuff&chr(10)
      elseif $action3 = 'c' Then
         $sendbuff = $sendbuff&chr(13)
      else
         $sendbuff = $sendbuff&chr(13)&chr(10)
      EndIf
      debug_write(0,@ScriptLineNumber&" - "&"i="&$i&" $action3="&$action3&" sendbuff="&$sendbuff)
      Send($sendbuff ,1)
      If $IncompProgAction[$Incomp]<> "" Then
         If $action1 = "a" OR $action1 = "l" Then
            If $line = 0 Then
               If ($action2 = "f") OR ($action2 = "a") Then
                  Send($IncompProgAction[$Incomp])
               EndIf
            elseIf $line = 1 Then
               If ($action2 = "n") OR ($action2 = "a") OR ($action2 = "s") Then
                  Send($IncompProgAction[$Incomp])
               EndIf         
            elseIf $i = $len Then
               If $action2 = "a" Then
                  Send($IncompProgAction[$Incomp])
               EndIf
            else
               If ($action2 = "n") OR ($action2 = "a") Then
                  Send($IncompProgAction[$Incomp])
               EndIf
            EndIf
         EndIf
      EndIf
      If $i > 0 Then
         $clip = StringRight($clip, $len-$i)
      Else
         $clip = ""
      EndIf
      $line = $line + 1
      $len = StringLen($clip)
   WEnd
EndFunc

Func StoreClip($StoreBmp = 0)
   Local $currentClip, $i, $je, $filecreated = -1, $error
	Local $FTime, $jeF, $backupclip = ""
   $currentClip = clip_get($StoreBmp)
	$error=@error
   If $AutoClearQueue = 1 And $maxcurclip + 1 >= $LimitList-1 And $ClearQueue = 0 Then
      $ClearQueue = 1
      MsgBox (4096,default,show_mess(54))
      massdelete()
      clip_put($currentClip)
   EndIf
   debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip+1&" formats="&_ClipBoard_CountFormats ()&" @error="&$error,"StoreClip")
   If $error<0 Then
      If $closeClipboard Then
  		  _ClipBoard_Close()
  		  $closeClipboard = 0
         $hbitmap = 0
      EndIf
      SetError(1)
      Return
   EndIf
   debug_write(0,@ScriptLineNumber&" - "&"Return 0 StoreClip"&" $currentClip="&$currentClip&" $cliplist[$showclip][0]="&$cliplist[$showclip][0]&" $showclip="&$showclip,"StoreClip")
   If $currentClip == $cliplist[$showclip][0] Then
      debug_write(0,@ScriptLineNumber&" - "&"Return 0 StoreClip"&" $closeClipboard="&$closeClipboard,"StoreClip")
      If $closeClipboard Then
         _ClipBoard_Close()
         $closeClipboard = 0
			$hbitmap = 0
      EndIf
		SetError(0)
      Return
   EndIf
   If _ClipBoard_CountFormats () = 0 Or ($currentClip == $identBinary And is_bitmap()) Then
      debug_write(0,@ScriptLineNumber&" - "&"Return 2 StoreClip"&" $closeClipboard="&$closeClipboard,"StoreClip")
      If $closeClipboard Then
         _ClipBoard_Close()
         $closeClipboard = 0
			$hbitmap = 0
      EndIf
		SetError(2)
      Return
   EndIf
   ; Test if new clip in not yet stored in buffer
   ; Store picture for getting hash
   Sleep(100)  
   $je = -1
   debug_write(0,@ScriptLineNumber&" - "&"curclip="&$currentClip&" max="&$maxclip+1&" maxcur="&$maxcurclip+1&" $StoreBmp="&$StoreBmp,"StoreClip")
   ; Test if new clip in not yet stored in buffer
   If $maxcurclip + 1 <= $LimitList-1 Then
      If $maxcurclip=0 And $cliplist[$maxcurclip][4] = "F" Then
         $filecreated = 0
      Else
         $filecreated = $maxcurclip + 1
      EndIf       
      $cliplist[$filecreated][0]=$currentClip
      If $StoreBmp=1 And is_bitmap($filecreated) Then
         $FTime = @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC
         $cliplist[$filecreated][3] = $FTime
         $cliplist[$filecreated][4] = ""
         WriteToFile($filecreated, $StoreBmp)
         If $closeClipboard Then
            _ClipBoard_Close()
            $closeClipboard = 0
				$hbitmap = 0
         EndIf
         $backupclip = $cliplist[$filecreated][0]
         $currentClip = StringMid($cliplist[$filecreated][0],StringInStr($cliplist[$filecreated][0],"--",2,2)+2)
         debug_write(0,@ScriptLineNumber&" - "&"$currentClip="&$currentClip,"StoreClip")
         $jeF = -1
         For $i = $maxclip To 0 Step -1        
            debug_write(0,@ScriptLineNumber&" - "&"is_bitmap($i)="&is_bitmap($i)&" i="&$i&" $instr="&StringInStr($cliplist[$i][0],$IdentBitmap)&" $cliplist[$i][0]="&show_string(String_tool($i,$ShowLen)),"StoreClip")
            If $cliplist[$i][4]="F" Then
               $jeF = $i
            EndIf 
            If is_bitmap($i) Then
               debug_write(0,@ScriptLineNumber&" - "&"Loop $currentClip="&$currentClip&@cr& _
                  "                           String="&StringMid($cliplist[$i][0],StringInStr($cliplist[$i][0],"--",2,2)+2),"StoreClip")
               If $AllowDuplicity = 0 Then
                  If $currentClip == StringMid($cliplist[$i][0],StringInStr($cliplist[$i][0],"--",2,2)+2) Then
                     $je = $i
                     ExitLoop
                  EndIf
               EndIf
            EndIf 
         Next
         If $je = -1 And $jeF > -1 And $filecreated>0 Then
      	  $je = $jeF
			   DeleteClipFile ($je)
			   MoveClipFile ($filecreated, $je)
         EndIf
      Else
         $cliplist[$filecreated][0] = ""
         $cliplist[$filecreated][4] = "F"
         $filecreated = -1
      EndIf
   EndIf
   If $backupclip <> "" Then
      $currentClip = $backupclip
	EndIf
   If $filecreated = -1 Then 
      $jeF = -1
      For $i = $maxclip To 0 Step -1
     	   If $cliplist[$i][4]="F" Then
     		  $jeF = $i
         EndIf
         If $AllowDuplicity = 0 Then 
            If $currentClip == $cliplist[$i][0] Then
               $je = $i
               ExitLoop
            EndIf
         EndIf 
      Next
      If $je = -1 And $jeF > -1 Then
         $je = $jeF
         $cliplist[$je][0]=$currentClip
         $FTime = @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC
         $cliplist[$je][3] = $FTime
         $cliplist[$je][4]=""
         ;Store text clip, BMP is handled above
         WriteToFile($je, 0)
      EndIf
      If $je > -1 Then
         ; Refresh last update time for clip only
         $FTime = @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC
         $cliplist[$je][3] = $FTime
         $FTime = @YEAR & @MON & @MDAY & @HOUR & @MIN & @SEC
         FileSetTime($DirName&"\"&$curclip+1&".txt",$FTime, 0)
      EndIf                                     
   EndIf
   ; If clip is new one, store it into buffer
   debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip+1&" max="&$maxclip+1&" maxcur="&$maxcurclip+1&" je="&$je+1&" $currentClip="&$currentClip&" $filecreated="&$filecreated,"StoreClip")
   If $je = -1 Then
      ; Shift pointer to current clip in buffer
      ; Binary format is only information message, it is not stored into buffer
      If NOT ($cliplist[$maxcurclip][0] == $IdentBinary OR $cliplist[$maxcurclip][4] = "F" OR  $store_clip == 0) Then
         $curclip = $maxcurclip + 1
      Else
         $curclip = $maxcurclip
      EndIf
      debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip&" max="&$maxclip&" $cliplist[$maxcurclip][0]="&$cliplist[$maxcurclip][0],"StoreClip")
      If $curclip > $LimitList-1 then
         $curclip = $maxcurclip
      EndIf;
      ; Set high water mark
      If $maxclip < $curclip Then
         $maxclip = $curclip
      EndIf;
      If $maxcurclip < $curclip Then
         $maxcurclip = $curclip
      EndIf;
   	; Store clip into buffer
      If $BeepDuration <> 0 Then
         Beep ($BeepFrequency, $BeepDuration)
      EndIf
      $cliplist[$curclip][0] = $currentClip
  	   $FTime = @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC
      $cliplist[$curclip][3] = $FTime
      $cliplist[$curclip][4] = ""
      debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip+1&" max="&$maxclip+1&" $filecreated="&$filecreated,"StoreClip")
      If $filecreated = -1 Then
         WriteToFile($curclip, $StoreBmp)
      EndIf
   Else
      $curclip = $je
      If $filecreated > 0 Then
         DeleteClipFile($filecreated)
      EndIf     
   EndIf
   debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip+1&" max="&$maxclip+1,"StoreClip")
   If $closeClipboard Then
  	   _ClipBoard_Close()
  	   $closeClipboard = 0
		$hbitmap = 0
   EndIf
   ; Start show clips at current clip
   $showclip = $curclip
   debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip+1&" max="&$maxclip+1&" maxcur="&$maxcurclip+1&" je="&$je+1&" $showclip="&$showclip+1,"StoreClip")
EndFunc

Func StoreClipFull()
	local $tmp
	If $store_clip = 1 Then
    Sleep(250)
	  StoreClip(1)
	  $tmp = @error
		If $tmp<>0 Then
			$tmp = "Error getting clip "&$tmp
		Else
		  $tmp = String_tool($showclip, $ShowLen)
		  Show_Tool($tmp,1)
		  Tray_tool($showclip)
		  ; Destroy clips windows after release Control key
		  while _IsPressed("11",$dll)
		     Sleep($ShowTime)
		  WEnd
		EndIf
	EndIf
  Show_Tool("",0)
EndFunc

Func nextv()
  ; Shift pointer to show clip up
	$numclip = 0
  If $IsCReleased = 1 Then
  	If $showclip >= $maxclip then
    	$showclip = 0
    Else
    	$showclip =  $showclip + 1
    EndIf;
	  If $cliplist[$showclip][4] = "F" And $showclip <> $maxclip Then
			nextv()
		EndIf
    $ClearBuff = 0
    $IsCReleased = 0
	EndIf
EndFunc

Func prevv()
      ; Shift pointer to show clip down
	$numclip = 0
  If $IsVReleased = 1 Then
  	If $showclip = 0 then
    	$showclip =  $maxclip
    Else
         $showclip =  $showclip - 1
    EndIf;
   	If $cliplist[$showclip][4] = "F" And $showclip <> $maxclip Then
    	prevv()
   	EndIf
    $ClearBuff = 0
    $IsVReleased = 0
	EndIf
EndFunc

Func clearx()
  ; Shift pointer to show clip up
   $numclip = 0
   If $IsXReleased = 1 Then
      if $ClearBuff = 2 then
         $ClearBuff = 3
      elseif $ClearBuff = 0 then
         $ClearBuff = 2
      elseif $ClearBuff = 3 then
         $ClearBuff = 4
      elseif $ClearBuff = 4 then
         $ClearBuff = 5
      elseif $ClearBuff = 5 then
         $ClearBuff = 1
      else
         ; 1
         $ClearBuff = 2
      endif
      $IsXReleased = 0
   EndIf
EndFunc

func set_text()
   If NOT is_bitmap($showclip) Then
      clip_put($cliplist[$showclip][0])
      $curclip = $showclip
     	WriteToFile($curclip)
   EndIf 
endfunc

func set_fullnet()
  Local $net, $drive, $pos
  If NOT is_bitmap($showclip) Then
    $pos = StringInStr($cliplist[$showclip][0],":\",2,1)-1
    If $pos = 1 Then
      $drive= StringMid($cliplist[$showclip][0],$pos,2)
      $net = DriveMapGet($drive)
		  debug_write(0,@ScriptLineNumber&" - "&"$drive="&$drive&" $net="&$net,"set_fullnet")
      If $net <> "" Then      	 	
  			clip_put(StringReplace($cliplist[$showclip][0],$drive,$net))
  			StoreClip(0)
    	EndIf
		Else
		  debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip+1&" pos="&$pos,"set_fullnet")
    EndIf
	EndIf 
endfunc

func set_lower()
   If NOT is_bitmap($showclip) Then
      $cliplist[$showclip][0]=StringLower($cliplist[$showclip][0])
      clip_put($cliplist[$showclip][0])
      $curclip = $showclip
     	WriteToFile($curclip)
   EndIf 
endfunc

func set_upper()
   If NOT is_bitmap($showclip) Then
      $cliplist[$showclip][0]=StringUpper($cliplist[$showclip][0])
      clip_put($cliplist[$showclip][0])
      $curclip = $showclip
     	WriteToFile($curclip)
   EndIf 
endfunc

Func setnum($num)   
  ; Set pointer to specific number
  $DebugProg="setnum"
  $showclip = 10*$numclip+$num-1
  if $showclip > $maxclip then
  	if $num-1 > $maxclip then
     	$showclip =  0
  	else
  		$showclip =  $num-1
  	endif
  elseif $showclip < 0 then
     $showclip =  0
  endif;
  While $cliplist[$showclip][4] = "F" And $showclip < $maxclip
     $showclip = $showclip+1
  WEnd
  $numclip = $showclip+1
  $ClearBuff = 0
  debug_write(0,@ScriptLineNumber&" - "&"$is_preview="&$is_preview&" $showclip="&$showclip)
  If $is_preview = 1 Then
    _GUICtrlButton_Click($ButtonFictive)
  EndIf
EndFunc

Func set0()
   setnum(0)
EndFunc

Func set1()
   setnum(1)
EndFunc

Func set2()
   setnum(2)
EndFunc

Func set3()
   setnum(3)
EndFunc

Func set4()
   setnum(4)
EndFunc

Func set5()
   setnum(5)
EndFunc

Func set6()
   setnum(6)
EndFunc

Func set7()
   setnum(7)
EndFunc

Func set8()
   setnum(8)
EndFunc

Func set9()
   setnum(9)
EndFunc

FUNC init_viewer()
   $DebugProg="init_viewer"
   debug_write(0,@ScriptLineNumber&" - "&"$is_control="&$is_control&" $is_preview="&$is_preview&" $is_setv="&$is_setv)
   IF $store_clip = 0 THEN
      ; Shut down clipboard viewer
      $RegisteringClipboard = 0
      TrayItemSetState($showcopy,$TRAY_UNCHECKED)
   ELSE
      ; registering clipboard
      $RegisteringClipboard = 1
      register_viewer()
      TrayItemSetState($showcopy,$TRAY_CHECKED)
   EndIf   
ENDFUNC

Func edit_clip()
  Local $File,$FileName, $lineno, $hWnd
  If is_RO($showclip) Then
    Return
  EndIf
  $lineno = $showclip
  $RegisteringClipboard = 0
  If is_bitmap($lineno) Then
    If $BitmapEditor = "" Or $is_setv = 1 Then
      show_bmp($lineno)
    Else
      RunWait($BitmapEditor&" "&$lineno+1&$BmpExt,$DirName,@SW_SHOW)
      WriteToFile($lineno)
      If $lineno = $curclip Then
        Retrieve_bitmap($curclip)
      EndIf
    EndIf
  Else
    If $TextEditor = "" Or $is_setv = 1 Then
      ReWriteClip($lineno)
    Else
      $FileName = $DirName&"\"&$lineno+1&".txt"
      RunWait($TextEditor&" "&$lineno+1&".txt",$DirName,@SW_SHOW)
      $file = FileOpen($FileName, 0)
      If $file = -1 Then
        MsgBox(4096, Default,show_mess(11,$FileName))
      Else
        $cliplist[$lineno][0] = FileRead($file)
        FileClose($file)
      EndIf
      If $lineno = $curclip Then
        Clip_put($cliplist[$lineno][0])
      EndIf
    EndIf
  EndIf
  set_keys()
	debug_write(0,@ScriptLineNumber&" - "&"time="&$cliplist[$lineno][3]&" $lineno="&$lineno,"edit_clip")      
EndFunc

Func set_keys()
   $DebugProg="set_keys"
   debug_write(0,@ScriptLineNumber&" - "&"$is_control="&$is_control&" $is_preview="&$is_preview&" $is_setv="&$is_setv)
   If $is_control = 0 And $is_preview = 0 And $is_setv = 1 Then 
      HotKeySet("^v", "prevv")
      HotKeySet("^c", "nextv")
      HotKeySet("^{UP}", "nextv")
      HotKeySet("^{DOWN}", "prevv")
      HotKeySet("^x", "clearx")
      HotKeySet("^f", "show_list")
      HotKeySet("^{NUMPAD0}", "set0")
      HotKeySet("^{NUMPAD1}", "set1")
      HotKeySet("^{NUMPAD2}", "set2")
      HotKeySet("^{NUMPAD3}", "set3")
      HotKeySet("^{NUMPAD4}", "set4")
      HotKeySet("^{NUMPAD5}", "set5")
      HotKeySet("^{NUMPAD6}", "set6")
      HotKeySet("^{NUMPAD7}", "set7")
      HotKeySet("^{NUMPAD8}", "set8")
      HotKeySet("^{NUMPAD9}", "set9")
      HotKeySet("^0", "set0")
      HotKeySet("^1", "set1")
      HotKeySet("^2", "set2")
      HotKeySet("^3", "set3")
      HotKeySet("^4", "set4")
      HotKeySet("^5", "set5")
      HotKeySet("^6", "set6")
      HotKeySet("^7", "set7")
      HotKeySet("^8", "set8")
      HotKeySet("^9", "set9")
      HotKeySet("^é", "set0")
      HotKeySet("^+", "set1")
      HotKeySet("^ě", "set2")
      HotKeySet("^š", "set3")
      HotKeySet("^č", "set4")
      HotKeySet("^ř", "set5")
      HotKeySet("^ž", "set6")
      HotKeySet("^ý", "set7")
      HotKeySet("^á", "set8")
      HotKeySet("^í", "set9")
      HotKeySet("^t", "set_text")
      HotKeySet("^l", "set_lower")
      HotKeySet("^u", "set_upper")
      HotKeySet("^n", "set_fullnet")
      HotKeySet("^b", "edit_clip")
      HotKeySet("{Esc}","Escape")
      HotKeySet("^#{Esc}","Escape")
      HotKeySet("^{PGDN}")
      HotKeySet("^{PGUP}")
    	HotKeySet("{PGDN}")
    	HotKeySet("{PGUP}")
      HotKeySet("{UP}")
      HotKeySet("{DOWN}")
      HotKeySet("{ENTER}")
      HotKeySet("^{ENTER}")
      HotKeySet("{DELETE}")
      HotKeySet("^{DELETE}")
      HotKeySet("{F1}")
      HotKeySet("^{F1}")
   Else
     ; Map keys for gui control
      If $is_control = 1 Or $is_preview = 1 Then
   		HotKeySet("^v", "setendguiv")
     		HotKeySet("^c", "setendguiv")
     		HotKeySet("^x", "setendgui")
     	Else
     	   HotKeySet("^v", "setv")
         HotKeySet("^c")
         HotKeySet("^x")
     	EndIf
      If $is_control = 0 And $is_preview = 1 Then
      	HotKeySet("^{PGDN}", "setguipgdn")
      	HotKeySet("^{PGUP}", "setguipgup")
      	HotKeySet("{PGDN}", "setguipgdn")
      	HotKeySet("{PGUP}", "setguipgup")
      	HotKeySet("^{UP}", "setguiup")
      	HotKeySet("^{DOWN}", "setguidown")
      	HotKeySet("{UP}", "setguiup")
      	HotKeySet("{DOWN}", "setguidown")
         HotKeySet("{ENTER}","setguienter")
         HotKeySet("^{ENTER}","setguienter")
         HotKeySet("{DELETE}","Delete1Clip")
         HotKeySet("^{DELETE}","Delete1Clip")
         ; numbers for choosing clip by number (control)
         HotKeySet("^{NUMPAD0}", "set0")
         HotKeySet("^{NUMPAD1}", "set1")
         HotKeySet("^{NUMPAD2}", "set2")
         HotKeySet("^{NUMPAD3}", "set3")
         HotKeySet("^{NUMPAD4}", "set4")
         HotKeySet("^{NUMPAD5}", "set5")
         HotKeySet("^{NUMPAD6}", "set6")
         HotKeySet("^{NUMPAD7}", "set7")
         HotKeySet("^{NUMPAD8}", "set8")
         HotKeySet("^{NUMPAD9}", "set9")
         HotKeySet("^0", "set0")
         HotKeySet("^1", "set1")
         HotKeySet("^2", "set2")
         HotKeySet("^3", "set3")
         HotKeySet("^4", "set4")
         HotKeySet("^5", "set5")
         HotKeySet("^6", "set6")
         HotKeySet("^7", "set7")
         HotKeySet("^8", "set8")
         HotKeySet("^9", "set9")
         HotKeySet("^é", "set0")
         HotKeySet("^+", "set1")
         HotKeySet("^ě", "set2")
         HotKeySet("^š", "set3")
         HotKeySet("^č", "set4")
         HotKeySet("^ř", "set5")
         HotKeySet("^ž", "set6")
         HotKeySet("^ý", "set7")
         HotKeySet("^á", "set8")
         HotKeySet("^í", "set9")
        ; numbers for choosing clip by number (without control)
         HotKeySet("{NUMPAD0}", "set0")
         HotKeySet("{NUMPAD1}", "set1")
         HotKeySet("{NUMPAD2}", "set2")
         HotKeySet("{NUMPAD3}", "set3")
         HotKeySet("{NUMPAD4}", "set4")
         HotKeySet("{NUMPAD5}", "set5")
         HotKeySet("{NUMPAD6}", "set6")
         HotKeySet("{NUMPAD7}", "set7")
         HotKeySet("{NUMPAD8}", "set8")
         HotKeySet("{NUMPAD9}", "set9")
         HotKeySet("0", "set0")
         HotKeySet("1", "set1")
         HotKeySet("2", "set2")
         HotKeySet("3", "set3")
         HotKeySet("4", "set4")
         HotKeySet("5", "set5")
         HotKeySet("6", "set6")
         HotKeySet("7", "set7")
         HotKeySet("8", "set8")
         HotKeySet("9", "set9")
         HotKeySet("é", "set0")
         HotKeySet("+", "set1")
         HotKeySet("ě", "set2")
         HotKeySet("š", "set3")
         HotKeySet("č", "set4")
         HotKeySet("ř", "set5")
         HotKeySet("ž", "set6")
         HotKeySet("ý", "set7")
         HotKeySet("á", "set8")
         HotKeySet("í", "set9")
      	HotKeySet("{F1}", "set_about")
      	HotKeySet("^{F1}", "set_about")
      Else
      	HotKeySet("^{PGDN}")
      	HotKeySet("^{PGUP}")
      	HotKeySet("{PGDN}")
      	HotKeySet("{PGUP}")
      	HotKeySet("^{UP}")
      	HotKeySet("^{DOWN}")
      	HotKeySet("{UP}")
      	HotKeySet("{DOWN}")
         HotKeySet("{ENTER}")
         HotKeySet("^{ENTER}")
         HotKeySet("{DELETE}")
         HotKeySet("^{DELETE}")
        ; numbers for choosing clip by number (control)
         HotKeySet("^{NUMPAD0}")
         HotKeySet("^{NUMPAD1}")
         HotKeySet("^{NUMPAD2}")
         HotKeySet("^{NUMPAD3}")
         HotKeySet("^{NUMPAD4}")
         HotKeySet("^{NUMPAD5}")
         HotKeySet("^{NUMPAD6}")
         HotKeySet("^{NUMPAD7}")
         HotKeySet("^{NUMPAD8}")
         HotKeySet("^{NUMPAD9}")
         HotKeySet("^0")
         HotKeySet("^1")
         HotKeySet("^2")
         HotKeySet("^3")
         HotKeySet("^4")
         HotKeySet("^5")
         HotKeySet("^6")
         HotKeySet("^7")
         HotKeySet("^8")
         HotKeySet("^9")
         HotKeySet("^é")
         HotKeySet("^+")
         HotKeySet("^ě")
         HotKeySet("^š")
         HotKeySet("^č")
         HotKeySet("^ř")
         HotKeySet("^ž")
         HotKeySet("^ý")
         HotKeySet("^á")
         HotKeySet("^í")
        ; numbers for choosing clip by number (without control)
         HotKeySet("{NUMPAD0}")
         HotKeySet("{NUMPAD1}")
         HotKeySet("{NUMPAD2}")
         HotKeySet("{NUMPAD3}")
         HotKeySet("{NUMPAD4}")
         HotKeySet("{NUMPAD5}")
         HotKeySet("{NUMPAD6}")
         HotKeySet("{NUMPAD7}")
         HotKeySet("{NUMPAD8}")
         HotKeySet("{NUMPAD9}")
         HotKeySet("0")
         HotKeySet("1")
         HotKeySet("2")
         HotKeySet("3")
         HotKeySet("4")
         HotKeySet("5")
         HotKeySet("6")
         HotKeySet("7")
         HotKeySet("8")
         HotKeySet("9")
         HotKeySet("é")
         HotKeySet("+")
         HotKeySet("ě")
         HotKeySet("š")
         HotKeySet("č")
         HotKeySet("ř")
         HotKeySet("ž")
         HotKeySet("ý")
         HotKeySet("á")
         HotKeySet("í")
      	HotKeySet("{F1}")
      	HotKeySet("^{F1}")
      EndIf
      If $is_control = 0 And $is_preview = 0 And $is_setv = 0 Then
         init_viewer()
      EndIf
  		HotKeySet("^b")
      HotKeySet("^t")
      HotKeySet("^l")
      HotKeySet("^u")
      HotKeySet("^n")
      HotKeySet("^f")
      HotKeySet("{Esc}")
   EndIf
EndFunc

Func Show_Tool($text, $delay = 0)
   Local $x, $y
   If $ShowTime > 0 Then
      If $ToolHeight < 0 Then
         $x =  Int(@DesktopHeight)+ $ToolHeight         
      Else
         $x =  $ToolHeight
      EndIf
      If $ToolWidth < 0 Then
         $y =  Int(@DesktopWidth)+ $ToolWidth
      Else
         $y =  $ToolWidth
      EndIf
      If $x <> 0 OR $y <> 0 Then
         ToolTip($text, $x, $y)
      Else
         ToolTip($text)      
      EndIf
   EndIf
   IF $delay = 1 Then
      Sleep($ShowTime)
   EndIf
EndFunc

Func show_mess($i,$s1 = "",$s2 = "",$s3 = "",$s4 = "",$s5 = "")
	local $tmp
	$tmp = StringReplace($msg[$i],"[1]",$s1)
	$tmp = StringReplace($tmp,"[2]",$s2)
	$tmp = StringReplace($tmp,"[3]",$s3)
	$tmp = StringReplace($tmp,"[4]",$s4)
	$tmp = StringReplace($tmp,"[5]",$s5)	
	$tmp = StringReplace($tmp,"\\",chr(7))	
	$tmp = StringReplace($tmp,"\n",chr(13))	
	$tmp = StringReplace($tmp,"\t",chr(9))	
	$tmp = StringReplace($tmp,chr(7),"\")	
  Return ($tmp)
endfunc

Func show_bmp($lineno =  $showclip)
   $DebugProg="show_bmp"
   Local $guibmp, $my_msg, $fname, $hImage, $IHeight, $IWidth, $CHeight, $CWidth
   $fname = file_bitmap ($lineno)
   If $fname <> "" Then
      $CHeight=Abs($ImageHeight) 
      $CWidth=Abs($ImageWidth) 
      debug_write(0,@ScriptLineNumber&" - "&"$CHeight="&$CHeight&" $CWidth="&$CWidth&" $IHeight="&$IHeight&" $IWidth="&$IWidth&" $is_setv="&$is_setv)
      If NOT ($BmpExt = ".bmp" Or $BmpExt = ".jpg" Or $BmpExt = ".gif") Or ($ImageHeight < 0) Then
         _GDIPlus_Startup()
         $hImage   = _GDIPlus_ImageLoadFromFile($fname)
         If $ImageHeight < 0 Then
            $IHeight=_GDIPlus_ImageGetHeight($hImage)
            $CHeight=$IHeight*Abs($ImageHeight)/100
            If $CHeight>$IHeight Then
               $CHeight=$IHeight
            EndIf
         EndIf
         If $IWidth < 0 Then
            $IWidth=_GDIPlus_ImageGetWidth($hImage)
            $CWidth=$IWidth*Abs($ImageWidth)/100
            If $CWidth>$IWidth Then
               $CWidth=$IWidth
            EndIf
         EndIf
         If NOT ($BmpExt = ".bmp" Or $BmpExt = ".jpg" Or $BmpExt = ".gif") Then 
            $fname = $DirName & "\"&$lineno+1&".jpg"
            _GDIPlus_ImageSaveToFile ($hImage, $fname)
         EndIf
         _GDIPlus_ImageDispose($hImage)
         _GDIPlus_ShutDown()
      EndIf
      debug_write(0,@ScriptLineNumber&" - "&"$CHeight="&$CHeight&" $CWidth="&$CWidth&" $IHeight="&$IHeight&" $IWidth="&$IWidth)
      $guibmp = GUICreate($fname, $CWidth, $CHeight, -1, -1, $WS_SIZEBOX + $WS_SYSMENU)
      $is_control = 1
      set_keys()
      GUICtrlCreatePic($fname,1,1,$CWidth,$CHeight)
      WinActivate ($guibmp)
      GUISetState(@SW_SHOW,$guibmp)
      ; Run the GUI until the dialog is closed
      debug_write(0,@ScriptLineNumber&" - "&"WIN "&WinActive ($guibmp))
      While 1
         $my_msg = GUIGetMsg()
         Select
            Case NOT WinActive ($guibmp)
               debug_write(0,@ScriptLineNumber&" - "&"Win není­ aktivní­ "&$guibmp)
               ;WinActivate ($guibmp)
               ExitLoop
            Case $my_msg = $GUI_EVENT_CLOSE 
               ExitLoop
            Case NOT _IsPressed("11",$dll) AND $is_setv = 1 
               debug_write(0,@ScriptLineNumber&" - "&"nestisknut control ")
               ExitLoop
            Case $is_control = 2
              ExitLoop
         EndSelect
      WEnd
      If NOT ($BmpExt = ".bmp" Or $BmpExt = ".jpg" Or $BmpExt = ".gif") Then
         FileRecycle($fname)
      EndIf
      GUIDelete($guibmp)
      $is_control = 0
      set_keys()
   EndIf
EndFunc

#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Preview windows
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Func show_list()
	LOCAL $GuiStyles, $maxHeight, $maxWidth, $getmsg 
   Local $tmp, $tmp2, $guibmp, $my_msg, $hImage, $guistyle, $wintitle
	LOCAL $i = -1, $doubleclick
	Local $FontWith = 9, $pos, $j = -1
   Local $filemenu, $ManageDir, $refresh, $ChangeDir, $aboutitem, $exititem, $massRO, $CloseWin
   Local $clipmenu, $toupper, $tolower, $totext, $tonet, $sortId, $sortText, $sortName, $sortDate
	$doubleclick = TimerInit()
	$dblclck_diff = 0
   $is_preview = 1
 	debug_write(0,@ScriptLineNumber&" - activate show_list "&" $hWnd2="&$hWnd2&" $RestartView="&$RestartView,"show_list")
	IF $hWnd2<>0 Then
      SendKeepActive("")
      GUIDelete($hWnd2)
	EndIf
	; Store current clipboard
	; documentation about edit control: http://msdn.microsoft.com/en-us/library/bb775458(VS.85).aspx
   If $cliplist[0][4] = "F" And $showclip = 0 And $maxclip = 0 And $hWnd2 = 0 Then
      debug_write(0,@ScriptLineNumber&" - "&"Return - no clips","show_list")
      $RestartView = 0
      $is_preview = 0
      set_keys()
      Return
   EndIf
   If $RestartView = 0 Then
      If $is_setv = 0 Then 
         $RegisteringClipboard = 0
         StoreClip()
      EndIf
   Else
      $RestartView = 0
   EndIf
   debug_write(0,@ScriptLineNumber&" - "&"curclip="&$curclip+1&" max="&$maxclip+1&" maxcur="&$maxcurclip+1,"show_list") 
   $maxHeight = @DesktopHeight-100
   If $maxHeight < 0 Then
  	   $maxHeight = @DesktopHeight
   EndIf        
   $maxWidth = @DesktopWidth-100
   IF $maxWidth > 2000 Then
  	   $maxWidth = 2000
   ElseIf $maxWidth < 0 Then
  	   $maxWidth = @DesktopWidth 
   EndIf        
	Show_Tool("",0)
   set_keys()   
   $wintitle = show_mess(21)
   If $is_setv = 1 Then
  	   $wintitle = show_mess(21)&" "&show_mess(40)
   Else
  	   $wintitle = show_mess(21)
   EndIf
   $hWnd2 = GUICreate($wintitle,$maxWidth,$maxHeight)
   ; Menu
   $filemenu = GUICtrlCreateMenu(show_mess(43))
   $ManageDir  = GUICtrlCreateMenuItem(show_mess(25,$DirName), $filemenu)
   $refresh  = GUICtrlCreateMenuItem(show_mess(5), $filemenu)
   $ChangeDir  = GUICtrlCreateMenuItem(show_mess(23), $filemenu)
   $massRO  = GUICtrlCreateMenuItem(show_mess(44), $filemenu)
   $aboutitem  = GUICtrlCreateMenuItem(show_mess(6), $filemenu)
   $CloseWin   = GUICtrlCreateMenuItem(show_mess(51), $filemenu)
   $exititem   = GUICtrlCreateMenuItem(show_mess(7), $filemenu)
   ; Clip menu
   $clipmenu = GUICtrlCreateMenu(show_mess(46))
   $toupper  = GUICtrlCreateMenuItem(show_mess(47), $clipmenu)
   $tolower  = GUICtrlCreateMenuItem(show_mess(48), $clipmenu)
   $totext  = GUICtrlCreateMenuItem(show_mess(49), $clipmenu)
   $tonet   = GUICtrlCreateMenuItem(show_mess(50), $clipmenu)
   $sortId   = GUICtrlCreateMenuItem(show_mess(57), $clipmenu)
   $sortText   = GUICtrlCreateMenuItem(show_mess(58), $clipmenu)
   $sortName   = GUICtrlCreateMenuItem(show_mess(59), $clipmenu)
   $sortDate   = GUICtrlCreateMenuItem(show_mess(60), $clipmenu)
   ; Buttons
   $ButtonFictive= GUICtrlCreateButton("", 1, 1, 1, 1)  ; Fictive button
   $ButtonEdit = GUICtrlCreateButton(show_mess(31), 1, 0,125,24) ; Edit clip
   $ButtonName = GUICtrlCreateButton(show_mess(30), 126, 0,145,24)  ; Name clip  
   $ButtonMove = GUICtrlCreateButton(show_mess(26), 271, 0,145,24)  ; Move clip
   $ButtonRO   = GUICtrlCreateButton("", 416, 0,145,24)  ; ReadOnly clips
   $ButtonDelete = GUICtrlCreateButton(show_mess(3), 561, 0,160,24)  ; Delete clips
   $Button1Delete = GUICtrlCreateButton(show_mess(29,$showclip+1), 721, 0,145,24)  ; Delete 1 clips
   $ButtonFind = GUICtrlCreateButton(show_mess(34), 866, 0,145,24)  ; Find clips
   $ButtonH    = GUICtrlCreateButton("",1014, 0,145,24)  ; Hidden clips
   $showGUI = GUICtrlCreateListView("", 0, 24,$maxWidth,$maxHeight-24,BitOR(0x0000000D,$LVS_SINGLESEL))
   debug_write(0,@ScriptLineNumber&" - "&"$filemenu="&$filemenu&" $clipmenu="&$clipmenu&" $ButtonFictive="&$ButtonFictive&" $ButtonFind="&$ButtonFind&" $showGUI="&$showGUI,"show_list")
   _GUICtrlListView_SetUnicodeFormat($showGUI, True)
   If $is_setv = 1 Then
  	   GUICtrlSetBkColor($showGUI, $BgColorInsert); colour for insert clip in set_v mode
   Else
      GUICtrlSetBkColor($showGUI, $BgColorNormal) ; colour for standard mode
   EndIf
   ; Load images
   $hImage = _GUIImageList_Create()
   _GUIImageList_Add($hImage, _GUICtrlListView_CreateSolidBitMap($showGUI, 0xFF0000, 16, 16))
   _GUIImageList_Add($hImage, _GUICtrlListView_CreateSolidBitMap($showGUI, 0x00FF00, 16, 16))
   _GUIImageList_Add($hImage, _GUICtrlListView_CreateSolidBitMap($showGUI, 0x0000FF, 16, 16))
   _GUIImageList_Add($hImage, _GUICtrlListView_CreateSolidBitMap($showGUI, 0xFFFF00, 16, 16))
   _GUIImageList_Add($hImage, _GUICtrlListView_CreateSolidBitMap($showGUI, 0xFFC20E, 16, 16))
   _GUICtrlListView_SetImageList($showGUI, $hImage, 1)
   ; Add columns
 	_GUICtrlListView_InsertColumn($showGUI, 0, show_mess(32), 16+(5*$FontWith),1)
 	_GUICtrlListView_InsertColumn($showGUI, 1, show_mess(33), $maxWidth-4-(16+(5*$FontWith))-(20*$FontWith)-(18*$FontWith)-4)
 	_GUICtrlListView_InsertColumn($showGUI, 2, show_mess(38), (20*$FontWith))
 	_GUICtrlListView_InsertColumn($showGUI, 3, show_mess(41), (18*$FontWith))
 	_GUICtrlListView_InsertColumn($showGUI, 4, "", 0)
   Local $max_items
	GUISetState()
	WinActivate ($hWnd2)
	SendKeepActive($hWnd2)
   $max_items = initItems()
	$LineHeight = _GUICtrlListView_ApproximateViewHeight($showGUI,100)/100
	$PageLines = int(($maxHeight-24)/$LineHeight)-2
	$tmp = _GUICtrlListView_ApproximateViewHeight($showGUI,$PageLines)
	_WinAPI_SetWindowPos(GUICtrlGetHandle($showGUI), 0, 0, 24, $maxWidth-1, $tmp, $SWP_NOZORDER)
	$LineHeight = int(_GUICtrlListView_ApproximateViewHeight($showGUI,100)/100)
	$PageLines = $PageLines - 1
	debug_write(0,@ScriptLineNumber&" - "&"$tmp="&$tmp&" $maxWidth="&$maxWidth&" $maxHeight="&$maxHeight&" $LineHeight="&$LineHeight,"show_list")
	;_GUICtrlListView_Scroll($showGUI, 0,$showclip*$LineHeight )
	$pre_item = getItem($showclip)
	$itemno = $pre_item 
	;Sleep($ShowTime)
	debug_write(0,@ScriptLineNumber&" - Start "&"$itemno="&$itemno&" $showclip="&$showclip,"show_list")
	While 1
      $getmsg = GUIGetMsg()
      If $getmsg <> 0 And $getmsg <> -11 Then
         debug_write(0,@ScriptLineNumber&" - "&"GUIGetMsg $getmsg="&$getmsg&" $showclip="&$showclip,"show_list")
      EndIf
      Switch $getmsg
         Case $GUI_EVENT_CLOSE 
			   GUIDelete($hWnd2)
			   $hWnd2 = 0
      	   $numclip = 0
            ExitLoop           ;exit when you close window
        ; Buttons
        	Case $ButtonEdit
            $dblclck_diff = 100
            $numclip = 0
        	Case $ButtonName
            $numclip = 0
            SendKeepActive("")
            Name_Clip()
            If $is_setv = 1 Then
               $RestartView = 1
               ExitLoop
   			Else
               _GUICtrlListView_SetItemText($showGUI, $itemno, show_string(StringLeft($cliplist[$showclip][1], $Showlen)),2)
           	   GUISetState(@SW_SHOW,$hWnd2)
           	   WinActivate ($hWnd2)
           	   SendKeepActive($hWnd2)
   			EndIf
            Set_list_item($itemno)
        	Case $ButtonMove
            $numclip = 0
            SendKeepActive("")
            $is_setv=0
            $wintitle = show_mess(21)
            WinSetTitle ($hWnd2, "", $wintitle )
            GUICtrlSetBkColor($showGUI, $BgColorNormal)
            _GUICtrlListView_SetItemState($showGUI, $itemno, 0x000000, 0xFFFFFF)
            $PreClip = $showclip
            Move_Clip()
            $RestartView = 1
            ExitLoop
        	Case $ButtonDelete           
            $numclip = 0
            SendKeepActive("")
            $RestartView = 1
            $is_setv=0
            massdelete()
            ExitLoop
        	Case $Button1Delete
            $numclip = 0
            Delete1Clip()
        	Case $ButtonFind
            $numclip = 0
            SendKeepActive("")
            $RestartView = 1
            $is_setv=0
            Find_clip()
            ExitLoop
        	Case $ButtonFictive
            debug_write(0,@ScriptLineNumber&" - "&"$getmsg="&$getmsg&" $showclip="&$showclip,"show_list")
            _GUICtrlListView_SetItemState($showGUI, $itemno, 0x000000, 0xFFFFFF)
            $itemno = getItem($showclip)
            Set_list_item(getItem($showclip))
         Case $ButtonRO
            Set_RO($showclip)
            $itemno = getItem($showclip)
            debug_write(0,@ScriptLineNumber&" - "&"$itemnono="&$itemno&" $showclip="&$showclip,"show_list")
            $dblclck_diff = 0
            Set_list_item($itemno)
            ;I am not able to unfocus button, follow statements not work.
            ;With debug 2 it works.
            ;debug_write(0,@ScriptLineNumber&" - "&"$showclip="&$showclip+1&" hexstatus="&hex(_GUICtrlButton_GetState($ButtonRO)),"show_list")
            ;_GUICtrlButton_SetFocus($ButtonRO,False)
            ;debug_write(0,@ScriptLineNumber&" - "&"$showclip="&$showclip+1&" hexstatus="&hex(_GUICtrlButton_GetState($ButtonRO)),"show_list")
            ;_GUICtrlButton_SetState($ButtonRO,False)
            ;_GUICtrlButton_SetDontClick($ButtonRO)
            ;_GUICtrlButton_SetCheck($ButtonRO,$BST_UNCHECKED)
         Case $ButtonH
            Set_H($showclip)
            $itemno = getItem($showclip)
            debug_write(0,@ScriptLineNumber&" - "&"$itemnono="&$itemno&" $showclip="&$showclip,"show_list")
            $dblclck_diff = 0
            Set_list_item($itemno)
      ; Mouse click
         Case $GUI_EVENT_PRIMARYDOWN ;Mouse click
            $pos = MouseGetPos()
            ; debug_write(0,@ScriptLineNumber&" - "&"GUI_EVENT_PRIMARYDOWN $getmsg="&$getmsg&" $showclip="&$showclip&" $itemno="&$itemno&" $pos[0]="&$pos[0]&" $pos[1]="&$pos[1],"show_list")
            debug_write(0,@ScriptLineNumber&" - "&"Mouse x,y:"& $pos[0] & "," & $pos[1]&" $maxWidth="&$maxWidth&" $maxHeight="&$maxHeight&" $FontWith="&$FontWith,"show_list")
    	      If $pos[0]<$maxWidth-22 AND $pos[1]>24 AND $pos[1]<46 Then
               _GUICtrlListView_SetItemState($showGUI, $itemno, 0x000000, 0xFFFFFF)
               If $pos[0]<16+(5*$FontWith) Then
                  If $InitSort = 1 Then
                     $InitSort = -1
                  Else 
                     $InitSort = 1
                  EndIf
           	   ElseIf $pos[0]<$maxWidth-4-(20*$FontWith)-(18*$FontWith)-4 Then
                  If $InitSort = 2 Then
                     $InitSort = -2
                  Else 
                     $InitSort = 2
                  EndIf
           	   ElseIf $pos[0]<$maxWidth-4-(18*$FontWith)-4 Then
                  If $InitSort = 3 Then
                     $InitSort = -3
                  Else 
                     $InitSort = 3
                  EndIf
           	   Else
                  If $InitSort = 4 Then
                     $InitSort = -4
                  Else 
                     $InitSort = 4
                  EndIf
               EndIf
               sortItem($InitSort, $showGUI, $max_items)
               $itemno = _GUICtrlListView_GetNextItem($showGUI)
               debug_write(0,@ScriptLineNumber&" - "&"$itemno="&$itemno&" $showclip="&$showclip&" $InitSort="&$InitSort,"show_list")
            Else
               IF $pos[0]<$maxWidth-20 AND $pos[1]>24 THEN
                  $numclip = 0
                  ;$itemno=_GUICtrlListView_GetSelectionMark($showGUI)
                  $itemno = _GUICtrlListView_GetNextItem($showGUI)
                  If $itemno= $pre_item Then
   	          	   $dblclck_diff = TimerDiff($doubleclick)
                     $doubleclick = TimerInit()
                  Else
                     If $itemno>=0 And $itemno<= $maxclip And $itemno<> $pre_item Then
                        $showclip=getLine($itemno)
                        debug_write(0,@ScriptLineNumber&" - "&"$itemnono="&$itemno&" $showclip="&$showclip,"show_list")
   	              EndIf
                  EndIf
                  Set_list_item($itemno)
                  $pre_item = $itemno
                  log_item_state($showGUI,"Mouse click END")
               EndIf
   	      EndIf
      ; Menu items
         Case  $aboutitem
            msgbox(4096,default,set_about())
         Case  $refresh
            Init()
            $numclip = 0
            SendKeepActive("")
            $RestartView = 1
            $is_setv=0
            ExitLoop
       	Case $ChangeDir
            NewQueue("")
            $numclip = 0
            SendKeepActive("")
            $RestartView = 1
            $is_setv=0
            ExitLoop
       	Case $massRO
            massRO()
            $numclip = 0
            SendKeepActive("")
            $RestartView = 1
            $is_setv=0
            ExitLoop
       	Case $CloseWin
            GUIDelete($hWnd2)
            $hWnd2=0
            ExitLoop
       	Case $ManageDir
            Run(@ComSpec & " /c " & 'start "RClipStep" "'&@WorkingDir&"\"&$DirName&'"')
            $numclip = 0
            SendKeepActive("")
            $RestartView = 0
            $is_setv=0
            ExitLoop
       	Case $exititem
            Exit
       	; Clip menu
       	Case $totext
   			set_text()
       	Case $toupper
   			set_upper()
   			_GUICtrlListView_SetItemText($showGUI, $itemno, show_string(StringLeft($cliplist[$showclip][0], $Showlen)),1)
       	Case $tolower
   			set_lower()
   			_GUICtrlListView_SetItemText($showGUI, $itemno, show_string(StringLeft($cliplist[$showclip][0], $Showlen)),1)
       	Case $tonet
            set_fullnet()
            $numclip = 0
            SendKeepActive("")
            $RestartView = 1
            $is_setv=0
            ExitLoop
         Case $sortId
            If $InitSort = 1 Then
               $InitSort = -1
            Else 
               $InitSort = 1
            EndIf
            sortItem($InitSort, $showGUI, $max_items)
            $itemno = _GUICtrlListView_GetNextItem($showGUI)
         Case $sortText
            If $InitSort = 2 Then
               $InitSort = -2
            Else 
               $InitSort = 2
            EndIf
            sortItem($InitSort, $showGUI, $max_items)
            $itemno = _GUICtrlListView_GetNextItem($showGUI)
         Case $sortName
            If $InitSort = 3 Then
               $InitSort = -3
            Else 
               $InitSort = 3
            EndIf
            sortItem($InitSort, $showGUI, $max_items)
            $itemno = _GUICtrlListView_GetNextItem($showGUI)
         Case $sortDate
            If $InitSort = 4 Then
               $InitSort = -4
            Else 
               $InitSort = 4
            EndIf
            sortItem($InitSort, $showGUI, $max_items)         
            $itemno = _GUICtrlListView_GetNextItem($showGUI)
     	EndSwitch
      Select
         ; Many keys have different meaning, we cannot work in another window, we have to close control when it is not active
         Case NOT _IsPressed("11",$dll) AND $is_setv = 1 
            ; CRTL není stisknuto a je insert mode
    			GUIDelete($hWnd2)
    			$hWnd2 = 0
        		$numclip = 0
   			ExitLoop    ;exit when you leave window and you are in insert mode
         Case $is_control = 2
            $is_control = 0
            ExitLoop
         Case NOT WinActive ($hWnd2)
   			If $AutoDestroyPreview = 1 Then
               GUIDelete($hWnd2)
               $hWnd2 = 0
               $numclip = 0
   			Else
               SendKeepActive("")
   			EndIf
   			ExitLoop
         Case $dblclck_diff < 750 And $dblclck_diff > 0
            $dblclck_diff = 0
            SendKeepActive("")
            $is_setv=0
            $wintitle = show_mess(21)
            WinSetTitle ($hWnd2, "", $wintitle )
            GUICtrlSetBkColor($showGUI, $BgColorNormal)            
            Edit_clip()
            GUISetState(@SW_SHOW,$hWnd2)
            WinActivate ($hWnd2)
            SendKeepActive($hWnd2)
            Set_list_item($itemno)
         Case WinActive ($hWnd2)
             ; debug_write(0,@ScriptLineNumber&" - "&" $hWnd2="&$hWnd2,"show_list")
            SendKeepActive($hWnd2)
            $is_preview = 1
            set_keys()
      EndSelect
   WEnd
   If $RestartView = 0 Then
      If $is_setv = 0 Then 
         If  $curclip <> $showclip Then
            $curclip = $showclip
            If is_bitmap() Then
               Retrieve_bitmap($curclip)
            Else
               clip_put2 ($curclip)
            EndIf
            $tmp = String_tool($showclip, $ShowLen)
            Show_Tool($tmp,1)
            Tray_tool($showclip)
            Show_Tool("")
         EndIf      
      Else
     	   $tmp = String_tool($showclip, $ShowLen)
         Show_Tool($tmp,0)
			GUIDelete($hWnd2)
			$hWnd2 = 0
   		$numclip = 0
      EndIf
	EndIf
   SendKeepActive("")
   ; Registering viewer is handled by set_keys
   $is_preview = 0
   set_keys()
   debug_write(0,@ScriptLineNumber&" - End "&" $RestartView="&$RestartView&" $showclip(+)="&$showclip+1&" $hWnd2="&$hWnd2,"show_list")
   TraySetState()
ENDFUNC

Func GetSolidBitMap($clip)
   Local $Index = 100
   If is_bitmap($clip) Then
      $Index = 2
   EndIf
   If is_ro($clip) Then
      $Index = 1
   EndIf
   If $cliplist[$clip][2] = "C" Then
      $Index = 3
   EndIf
   If $cliplist[$clip][2] = "N" Then
      $Index = 4
   EndIf
   Return $Index
EndFunc

Func Set_list_item($item)
   Local $Line
   debug_write(0,@ScriptLineNumber&" - "&"$item="&$item&" $pre_item="&$pre_item&" $showGUI="&$showGUI,"Set_list_item")
   clear_item_state($showGUI)
   log_item_state($showGUI, "Po clearingu pro "&$item)
   $Line = getLine($item)
   _GUICtrlListView_SetItemImage($showGUI, $item, GetSolidBitMap($Line))
   If is_h($Line) Then
      _GUICtrlListView_SetItemText($showGUI, $item, "******",1)
   Else
      _GUICtrlListView_SetItemText($showGUI, $item, show_string(StringLeft($cliplist[$Line][0], $Showlen)),1)
   EndIf
   _GUICtrlListView_SetItemText($showGUI, $item, show_string(StringLeft($cliplist[$Line][1], $Showlen)),2)
   _GUICtrlListView_SetItemText($showGUI, $item, $cliplist[$Line][3],3)
   _GUICtrlListView_SetItemText($showGUI, $item, revertDate($cliplist[$Line][3]),4)
   _GUICtrlListView_SetItemCut ( $showGUI, $item, True )
   _GUICtrlListView_SetItemDropHilited ( $showGUI, $item, True )
   _GUICtrlListView_SetItemFocused ( $showGUI, $item, True )
   _GUICtrlListView_SetItemSelected ( $showGUI, $item, True )
   log_item_state($showGUI, "Po SetState pro "&$item)
   debug_write(0,@ScriptLineNumber&" - "&"time="&$cliplist[$line][3]&" Radek - $item="&$item&" clip - $line="&$line,"Set_list_item")         
   debug_write(0,@ScriptLineNumber&" - "&"4="&$cliplist[$line][4]&" Radek - $item="&$item&" clip - $line="&$line,"Set_list_item")
   _GUICtrlButton_SetText($Button1Delete,show_mess(29,$line+1))         
   If $cliplist[$Line][4] = "R" Then 
      _GUICtrlButton_SetText($ButtonRO,show_mess(45))
      _GUICtrlButton_Enable($ButtonRO,True)
		_GUICtrlButton_Enable($Button1Delete,False)
		_GUICtrlButton_Enable($ButtonEdit,False)
		_GUICtrlButton_Enable($ButtonH,True)
		_GUICtrlButton_SetText($ButtonH,show_mess(55))
      _GUICtrlButton_Enable($ButtonMove,False)
   ElseIf $cliplist[$Line][4] = "O" Then 
		_GUICtrlButton_SetText($ButtonRO,show_mess(45))
		_GUICtrlButton_Enable($ButtonRO,True)
		_GUICtrlButton_Enable($Button1Delete,False)
		_GUICtrlButton_Enable($ButtonEdit,False)
		_GUICtrlButton_Enable($ButtonH,True)
		_GUICtrlButton_SetText($ButtonH,show_mess(56))
      _GUICtrlButton_Enable($ButtonMove,False)
   ElseIf $cliplist[$Line][4] = "H" Then 
		_GUICtrlButton_Enable($ButtonH,True)
		_GUICtrlButton_SetText($ButtonH,show_mess(56))
		_GUICtrlButton_Enable($Button1Delete,True)
		_GUICtrlButton_Enable($ButtonEdit,True)
		_GUICtrlButton_SetText($ButtonRO,show_mess(44))
		_GUICtrlButton_Enable($ButtonRO,True)
      _GUICtrlButton_Enable($ButtonMove,True)
   ElseIf $cliplist[$Line][4] = "I" Then 
		_GUICtrlButton_SetText($ButtonRO,show_mess(45))
		_GUICtrlButton_Enable($ButtonRO,False)
		_GUICtrlButton_Enable($Button1Delete,False)
		_GUICtrlButton_Enable($ButtonEdit,False)
		_GUICtrlButton_Enable($ButtonH,False)
      _GUICtrlButton_Enable($ButtonMove,False)
		_GUICtrlButton_SetText($ButtonH,show_mess(55))
   Else
		_GUICtrlButton_SetText($ButtonRO,show_mess(44))
		_GUICtrlButton_Enable($ButtonRO,True)
		_GUICtrlButton_Enable($Button1Delete,True)
		_GUICtrlButton_Enable($ButtonEdit,True)
		_GUICtrlButton_Enable($ButtonH,True)
      _GUICtrlButton_Enable($ButtonMove,True)
		_GUICtrlButton_SetText($ButtonH,show_mess(55))
	EndIf		
   _GUICtrlListView_ClickItem ( $showGUI, $item, "right")
EndFunc

Func getItem($lineno)
  Local $tmp
  If $lineno > $maxclip Then
    $tmp = $maxclip
  ElseIf $lineno < 0 Then
    $tmp = 0
  Else
    $tmp = $lineno
  EndIf    
  debug_write(0,@ScriptLineNumber&" - $lineno="&$lineno&" $cliplist[$tmp][5]="&$cliplist[$tmp][5]&" $maxclip="&$maxclip&" $tmp="&$tmp,"getItem")
  Return $cliplist[$tmp][5]
EndFunc

Func getLine($item)
	Local $poz = 0, $max = 0, $pozmax = 0, $tmp
	If $item > 0 Then 
	  $tmp = $item
	Else
	  $tmp = 0
	EndIf  
	While $poz <= $maxclip
      If $cliplist[$poz][4] <> "F" Then 
         debug_write(0,@ScriptLineNumber&" - $poz="&$poz&" $cliplist[$poz][5]="&$cliplist[$poz][5]&" $item="&$item&" $pozmax="&$pozmax,"getLine")
         If $cliplist[$poz][5] = $tmp Then
            Return $poz
         ElseIf $cliplist[$poz][5] > $max Then
            $max = $cliplist[$poz][5]
            $pozmax = $poz	    
         EndIf
      EndIf
		$poz += 1  
	WEnd
  Return $pozmax
EndFunc

Func log_item_state($GUI, $pozice)
   Local $gui_index, $gui_state, $gui_item, $pocet = 0
   $gui_state = 1
   While $gui_state <= 8
      $gui_index = -1
      $gui_item = _GUICtrlListView_GetNextItem($GUI, $gui_index, 0, $gui_state)
      $gui_index = $gui_item         
      While $gui_item > -1 
         If $gui_item > -1 Then
            $pocet = $pocet + 1
            debug_write(0,@ScriptLineNumber&" - "&$pozice&": Nalezena pozice "&$gui_item&", Status="&$gui_state,"log_item_state")
         EndIf
         $gui_item = _GUICtrlListView_GetNextItem($GUI, $gui_index, 0, $gui_state)
         $gui_index = $gui_item
      WEnd
      $gui_index = 0
      $gui_state = 2 * $gui_state
   WEnd 
   If $pocet = 0 Then
      debug_write(0,@ScriptLineNumber&" - "&$pozice&": Zadne polozky","log_item_state")
   EndIf
EndFunc

Func clear_item_state($GUI)
   Local $gui_index, $gui_state, $gui_item, $pocet = 0
   $gui_state = 1
   While $gui_state <= 8
      $gui_index = -1
      $gui_item = _GUICtrlListView_GetNextItem($GUI, $gui_index, 0, $gui_state)
      $gui_index = $gui_item         
      While $gui_item > -1 
         _GUICtrlListView_SetItemCut ( $GUI, $gui_item , False )
         _GUICtrlListView_SetItemDropHilited ( $GUI, $gui_item , False )
         _GUICtrlListView_SetItemFocused ( $GUI, $gui_item , False )
         _GUICtrlListView_SetItemSelected ( $GUI, $gui_item, False )
         $gui_item = _GUICtrlListView_GetNextItem($GUI, $gui_index, 0, $gui_state)
         $gui_index = $gui_item
      WEnd
      $gui_index = 0
      $gui_state = 2 * $gui_state
   WEnd 
EndFunc

#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Preview windows - SORTING
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Func sortItem(ByRef $poz, $GUI, $max_items)
   Local $i, $j, $new_pre_item, $tmp, $direction, $my_poz   
   debug_write(0,@ScriptLineNumber&" - "&"$poz="&$poz&" $max_items="&$max_items,"sortItem")
   debug_write(0,@ScriptLineNumber&" - "&"$showclip="&$showclip,"sortItem")
   If $poz <> 0 Then
      ProgressOn(show_mess(61),show_mess(61), "0%",-1,-1,16)
      ProgressSet( 0,"0%")
      $new_pre_item = getLine($pre_item)
      debug_write(0,@ScriptLineNumber&" - PRE SORT "&"$new_pre_item="&$new_pre_item&" $pre_item="&$pre_item,"sortItem")
      $my_poz = abs($poz) 
      If $poz > 0 Then
         $direction = False;
      Else
         $direction = True;
      EndIf               
      debug_write(0,@ScriptLineNumber&" - "&"$direction="&$direction&" $poz="&$poz,"sortItem") 
      If $my_poz = 4 Then
         _GUICtrlListView_SimpleSort($GUI, $direction, $my_poz)
      Else
         _GUICtrlListView_SimpleSort($GUI, $direction, $my_poz -1)
      EndIf
      debug_write(0,@ScriptLineNumber&" - POST SORT "&"$new_pre_item="&$new_pre_item&" $pre_item="&$pre_item,"sortItem") 
      ProgressSet( 50,"50%")
  	   $i = -1
  	   WHILE $i<= $maxclip
         $i +=1
   		$cliplist[$i][5] = ""
   	WEND
      $i = -1
      WHILE $i< $max_items
         $i +=1
         $j = _GUICtrlListView_GetItemText($GUI, $i) - 1
         $cliplist[$j][5] = $i
         _GUICtrlListView_SetItem($GUI, $j+1, $i, 0, GetSolidBitMap($j))
#         debug_write(0,@ScriptLineNumber&" - "&"&i="&$i&" $j="&$j,"sortItem")
   	WEND
      ProgressSet( 100,"100%")
      sleep(200)
      ProgressOff()
      debug_write(0,@ScriptLineNumber&" - "&"$showclip="&$showclip,"sortItem")
      $pre_item = getItem($new_pre_item) 
      $itemno = getItem($showclip)
      Set_list_item($itemno)
   EndIf      
EndFunc

Func revertDate($input)
	Local $Output = ""
	$Output = StringMid($input,7,4)&StringMid($input,3,3)&"."&StringMid($input,1,2)&StringMid($Input,11)
	Return $Output
EndFunc

Func push_heap($value, $index)
   Local $preItem, $Item
; Add value to the end of Heap
   $HeapLimit = $HeapLimit + 1;
   $Heap [$HeapLimit][0] = $value
   $Heap [$HeapLimit][1] = $index
   If mod($HeapLimit, 2) = 0 Then
      $preItem = $HeapLimit / 2
   Else
      $preItem = ($HeapLimit - 1) / 2
   EndIf
   $Item = $HeapLimit     
   While $preItem > 0
      If $Heap [$Item][0] > $Heap [$preItem][0] Then
         $Heap [$Item][0] = $Heap [$preItem][0]                   
         $Heap [$Item][1] = $Heap [$preItem][1]                   
         $Heap [$preItem][0] = $value
         $Heap [$preItem][1] = $index
         $Item = $preItem     
         If mod($preItem, 2) = 0 Then
            $preItem = $preItem / 2
         Else
            $preItem = ($preItem - 1) / 2
         EndIf
      Else
         $preItem = 0
      EndIf
   WEnd
#   if $HeapLimit < 0 Then 
#      debug_write(1,@ScriptLineNumber&" - push_heap "&" $HeapLimit="&$HeapLimit,"push_heap")
#      printheap()
#   EndIf   
EndFunc

Func pop_heap(ByRef $value, ByRef $index)
   Local $NextItem, $Item, $pomvalue, $pomindex
   $Item = 1
   $value = $Heap [$Item][0] 
   $index = $Heap [$Item][1]
   $Heap [$Item][0] = $Heap [$HeapLimit][0]  
   $Heap [$Item][1] = $Heap [$HeapLimit][1]  
   $Heap [$HeapLimit][0] = ""  
   $Heap [$HeapLimit][1] = -100
   $HeapLimit = $HeapLimit - 1  
   While 2*$Item <= $HeapLimit
      If 2*$Item = $HeapLimit Then 
         If $Heap[$Item][0] < $Heap[2*$Item][0] Then
            $pomvalue = $Heap [$Item][0]  
            $pomindex = $Heap [$Item][1]  
            $Heap [$Item][0] = $Heap [2*$Item][0]  
            $Heap [$Item][1] = $Heap [2*$Item][1]  
            $Heap [2*$Item][0] = $pomvalue  
            $Heap [2*$Item][1] = $pomindex
            $Item = 2*$Item
         Else
            $Item = $HeapLimit
         EndIf            
      Else
         If $Heap[$Item][0] < $Heap[2*$Item][0] OR $Heap[$Item][0] < $Heap[(2*$Item)+1][0] Then
            If $Heap[2*$Item][0] > $Heap[(2*$Item)+1][0] Then
               $pomvalue = $Heap [$Item][0]  
               $pomindex = $Heap [$Item][1]  
               $Heap [$Item][0] = $Heap [2*$Item][0]  
               $Heap [$Item][1] = $Heap [2*$Item][1]  
               $Heap [2*$Item][0] = $pomvalue  
               $Heap [2*$Item][1] = $pomindex
               $Item = 2*$Item
            Else
               $pomvalue = $Heap [$Item][0]  
               $pomindex = $Heap [$Item][1]  
               $Heap [$Item][0] = $Heap [(2*$Item)+1][0]  
               $Heap [$Item][1] = $Heap [(2*$Item)+1][1]  
               $Heap [(2*$Item)+1][0] = $pomvalue  
               $Heap [(2*$Item)+1][1] = $pomindex
               $Item = (2*$Item)+1
            EndIf      
         Else
            $Item = $HeapLimit
         EndIf            
      EndIf
   WEnd
#   if $HeapLimit < -1 Then 
#      debug_write(1,@ScriptLineNumber&" - pop_heap "&" $HeapLimit="&$HeapLimit,"pop_heap")
#      printheap()
#   EndIf   
EndFunc

Func push_rheap($value, $index)
; Reverse heap - lowest value is in the top
   Local $preItem, $Item
; Add value to the end of Heap
   $HeapLimit = $HeapLimit + 1;
   $Heap [$HeapLimit][0] = $value
   $Heap [$HeapLimit][1] = $index
   If mod($HeapLimit, 2) = 0 Then
      $preItem = $HeapLimit / 2
   Else
      $preItem = ($HeapLimit - 1) / 2
   EndIf
   $Item = $HeapLimit     
   While $preItem > 0
      If $Heap [$Item][0] < $Heap [$preItem][0] Then
         $Heap [$Item][0] = $Heap [$preItem][0]                   
         $Heap [$Item][1] = $Heap [$preItem][1]                   
         $Heap [$preItem][0] = $value
         $Heap [$preItem][1] = $index
         $Item = $preItem     
         If mod($preItem, 2) = 0 Then
            $preItem = $preItem / 2
         Else
            $preItem = ($preItem - 1) / 2
         EndIf
      Else
         $preItem = 0
      EndIf
   WEnd
EndFunc

Func pop_rheap(ByRef $value, ByRef $index)
; Reverse heap - lowest value is in the top
   Local $NextItem, $Item, $pomvalue, $pomindex
   $Item = 1
   $value = $Heap [$Item][0] 
   $index = $Heap [$Item][1]
   $Heap [$Item][0] = $Heap [$HeapLimit][0]  
   $Heap [$Item][1] = $Heap [$HeapLimit][1]  
   $Heap [$HeapLimit][0] = ""  
   $Heap [$HeapLimit][1] = -100
   $HeapLimit = $HeapLimit - 1  
   While 2*$Item <= $HeapLimit
      If 2*$Item = $HeapLimit Then 
         If $Heap[$Item][0] > $Heap[2*$Item][0] Then
            $pomvalue = $Heap [$Item][0]  
            $pomindex = $Heap [$Item][1]  
            $Heap [$Item][0] = $Heap [2*$Item][0]  
            $Heap [$Item][1] = $Heap [2*$Item][1]  
            $Heap [2*$Item][0] = $pomvalue  
            $Heap [2*$Item][1] = $pomindex
            $Item = 2*$Item
         Else
            $Item = $HeapLimit
         EndIf            
      Else
         If $Heap[$Item][0] > $Heap[2*$Item][0] OR $Heap[$Item][0] > $Heap[(2*$Item)+1][0] Then
            If $Heap[2*$Item][0] < $Heap[(2*$Item)+1][0] Then
               $pomvalue = $Heap [$Item][0]  
               $pomindex = $Heap [$Item][1]  
               $Heap [$Item][0] = $Heap [2*$Item][0]  
               $Heap [$Item][1] = $Heap [2*$Item][1]  
               $Heap [2*$Item][0] = $pomvalue  
               $Heap [2*$Item][1] = $pomindex
               $Item = 2*$Item
            Else
               $pomvalue = $Heap [$Item][0]  
               $pomindex = $Heap [$Item][1]  
               $Heap [$Item][0] = $Heap [(2*$Item)+1][0]  
               $Heap [$Item][1] = $Heap [(2*$Item)+1][1]  
               $Heap [(2*$Item)+1][0] = $pomvalue  
               $Heap [(2*$Item)+1][1] = $pomindex
               $Item = (2*$Item)+1
            EndIf      
         Else
            $Item = $HeapLimit
         EndIf            
      EndIf
   WEnd   
EndFunc

Func initItems()
   Local $i, $j, $value, $show_progress
   $show_progress = 1000
   If $maxclip > $show_progress Then
      ProgressOn(show_mess(61),show_mess(61), "0%",-1,-1,16)
      ProgressSet( 0,"0%")
   EndIf;
   $i = 0  
   WHILE $i<= $maxclip
  	   IF $cliplist[$i][4] <> "F" THEN
         If $InitSort = 0 OR $InitSort = 1 Then
            push_rheap($i, $i)
         ElseIf  $InitSort = 2 Then
            push_rheap($cliplist[$i][0], $i)
         ElseIf  $InitSort = 3 Then
            push_rheap($cliplist[$i][1], $i)
         ElseIf  $InitSort = 4 Then
            push_rheap(revertDate($cliplist[$i][3]), $i)
         ElseIf $InitSort = -1 Then
            push_heap($i, $i)
         ElseIf  $InitSort = -2 Then
            push_heap($cliplist[$i][0], $i)
         ElseIf  $InitSort = -3 Then
            push_heap($cliplist[$i][1], $i)
         ElseIf  $InitSort = -4 Then
            push_heap(revertDate($cliplist[$i][3]), $i)
         ElseIf  $InitSort = 5 Then
            If $cliplist[$i][2] > "" Then 
               push_rheap($LimitList + 2 + $i, $i)
            Else
               push_rheap($i, $i)
            EndIf
         EndIf            
      EndIf
      $i +=1
   WEnd
   If $maxclip > $show_progress Then
      ProgressSet( 50,"50%")
   EndIf
   $j = 0
   WHILE $HeapLimit > 0
      If $InitSort >= 0 Then  
         pop_rheap($value, $i)
      Else
         pop_heap($value, $i)
      EndIf
      # debug_write(0,@ScriptLineNumber&" - after popHash "&"$HeapLimit="&$HeapLimit&" $i="&$i&" $maxclip="&$maxclip,"initItems") 
      _GUICtrlListView_AddItem($showGUI, $i + 1, GetSolidBitMap($i))
      If is_h($i) Then
         _GUICtrlListView_AddSubItem($showGUI, $j, "******",1)
      Else
         _GUICtrlListView_AddSubItem($showGUI, $j, show_string(StringLeft($cliplist[$i][0], $Showlen)),1)
      EndIf
      _GUICtrlListView_AddSubItem($showGUI, $j, show_string(StringLeft($cliplist[$i][1], $Showlen)),2)
      _GUICtrlListView_AddSubItem($showGUI, $j, $cliplist[$i][3], 3)
      _GUICtrlListView_AddSubItem($showGUI, $j, revertDate($cliplist[$i][3]),4)
      $cliplist[$i][5] = $j
      $j +=1
      # debug_write(0,@ScriptLineNumber&" - "&"$i+="&$i+1&" $j+="&$j+1&" 4="&$cliplist[$i][4]&" string="&show_string(StringLeft($cliplist[$i][0],50)),"initItems")
   WEND
   $itemno = getItem($showclip)
   Set_list_item($itemno)
   If $maxclip > $show_progress Then
      ProgressSet( 100,"100%")
      sleep(200)
      ProgressOff()
   EndIf;
   Return $j-1
EndFunc

Func printheap()
   Local $i = 1
   WHILE $i <= $HeapLimit
      debug_write(1,@ScriptLineNumber&" - Printheap "&" $i="&$i&" value="&$Heap[$i][0],"printheap")
      $i += 1
   WEnd
EndFunc      

#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Preview windows - clip navigation
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Func move_ctrl($shift)
  $DebugProg="move_ctrl"
  ;debug_write(0,@ScriptLineNumber&" - "&"$showclip="&$showclip+1&" hexstatus="&hex(_GUICtrlListView_GetItemState($showGUI, $itemno, 0xFFFFFF)))
  _GUICtrlListView_SetItemState($showGUI, $itemno, 0x000000, 0xFFFFFF)
  debug_write(0,@ScriptLineNumber&" - cleared itemno(+)"&$itemno+1)
  ;debug_write(0,@ScriptLineNumber&" - "&"$showclip="&$showclip+1&" hexstatus="&hex(_GUICtrlListView_GetItemState($showGUI, $itemno, 0xFFFFFF)))
	$showclip = getLine($itemno+$shift)
	$itemno = getItem($showclip)
  debug_write(0,@ScriptLineNumber&" - "&"$showclip(+)="&$showclip+1&" $shift="&$shift&" $itemno(+)="&$itemno+1)
  ; _GUICtrlListView_Scroll($showGUI, 0,$shift*$LineHeight )
  Set_list_item($itemno)
Endfunc

Func setguipgdn()
  move_ctrl($PageLines)
Endfunc

Func setguidown()
  move_ctrl(1)
Endfunc

Func setguipgup()
  move_ctrl(-$PageLines)
Endfunc

Func setguiup()
	move_ctrl(-1)
Endfunc

#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Clip manipulation (moving, deleting)
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Func Delete1Clip()
  Local $show
  If  $showclip < $maxclip-1 Then
  	$show =  $showclip
  Else
  	$show =  $maxclip-1
  EndIf
  $RestartView = 1
  DeleteClip($showclip,$showclip)
  If $Show > 0 And $cliplist[$Show][0]<>"" Then
  	$showclip = $Show
  EndIf
  $is_control  = 2
EndFunc

Func setendgui()
   $ClearBuff = 2
   $is_control  = 2
Endfunc

Func setendguiv()
   $ClearBuff = 0
   $is_control  = 2
Endfunc

Func setguienter()
   $dblclck_diff = 10
Endfunc

FUNC DeleteClip($from,$to)
  $DebugProg="DeleteClip"
  Local $OrigRegister
  $ClearBuff = 0
  $OrigRegister = $RegisteringClipboard
	$RegisteringClipboard = 0
  local $pocet, $loPos, $HiPos, $prestatus = 1
  local $i, $progress, $deleted,$highWaterMark
  If $to > $maxclip Then $to=$maxclip
  $pocet = $to - $from + 1
  $progress = $maxclip - $from + 1
  debug_write(0,@ScriptLineNumber&" - "&"$from="&$from+1&" $to="&$to+1&" $pocet="&$pocet&" $maxclip="&$maxclip+1)
   If $progress >= 10 Then
  	   ProgressOn(show_mess(16),show_mess(9,$from+1,$to+1), "0%",-1,-1,16)
   EndIf
  If $maxclip > 0 Then
		$loPos = $from
		$HiPos = $to+1
		$deleted  = 0
		$highWaterMark = $loPos - 1
		While $loPos <= $maxclip
			debug_write(0,@ScriptLineNumber&" - "&"$loPos="&$loPos+1&" $hiPos="&$hiPos+1&" $deleted="&$deleted&" $highWaterMark="&$highWaterMark+1)
      If round(100*($loPos-$from)/$progress) > $prestatus And $progress >= 10 Then
        $prestatus = round(100*($loPos-$from)/$progress)
      	ProgressSet( round(100*($loPos-$from)/$progress),round(100*($loPos-$from)/$progress)&"%")
        debug_write(0,@ScriptLineNumber&" - "&"$progress="&$progress&" $loPos="&$loPos+1&" $hiPos="&$hiPos+1)
      EndIf
			If is_RO($loPos) Then
      	debug_write(0,@ScriptLineNumber&" - Only shift, loPos=R "&"$loPos="&$loPos+1)
  			$loPos = $loPos +1
  			$highWaterMark = $loPos
				ContinueLoop
  		EndIf
  		If $hiPos<= $maxclip Then
				If is_RO($hiPos) Then
		      debug_write(0,@ScriptLineNumber&" - Only shift, hiPos=R  "&"$HIPos="&$HIPos+1)
	  			$hiPos = $hiPos +1
					ContinueLoop
				EndIf
			EndIf
      debug_write(0,@ScriptLineNumber&" - Delete loPos "&"$loPos="&$loPos+1&" $hiPos="&$hiPos+1)
			$deleted = $deleted + 1
  		DeleteClipFile($loPos)
      If $hiPos <= $maxclip Then
        debug_write(0,@ScriptLineNumber&" - Move hiPos to loPos "&"$loPos="&$loPos+1&" 4="&" $hiPos="&$hiPos+1)
        MoveClipFile($hiPos, $loPos)
        If $hiPos < $maxclip Then
          $hiPos = $hiPos +1
        EndIf
        $highWaterMark = $highWaterMark + 1
      EndIf
  		$loPos = $loPos +1
		WEnd
    If $progress >= 10 Then
		  ProgressSet( 100,"100%")
		EndIf
		Sleep(500)
    $maxclip = $highWaterMark
		debug_write(0,@ScriptLineNumber&" - End loop "&"$loPos="&$loPos+1&" $hiPos="&$hiPos+1&" $deleted="&$deleted&" $highWaterMark="&$highWaterMark+1)
    If $maxclip < 0 Then 
    	$maxclip = 0
      clip_put ("")
    EndIf      
	Else
  	If is_RO(0) Then
  		msgbox(4096,default,show_mess(42,1))
		  If $progress >= 10 Then
		  	ProgressOff()
		  EndIf
  		Return
  	EndIf
  	DeleteClipFile(0)
  EndIf
  While $cliplist[$maxclip][0] = "" And $maxclip > 0  
  	$maxclip = $maxclip - 1
  WEnd
  If $maxcurclip>$maxclip Then  $maxcurclip = $maxclip  
  $curclip =$maxclip 
  $showclip = $curclip
  debug_write(0,@ScriptLineNumber&" - "&"$cliplist[0][0]=<"&$cliplist[0][0]&"> $curclip="&$curclip+1&" $maxclip="&$maxclip+1)
  clip_put2 ($curclip)
  If $progress >= 10 Then
  	ProgressOff()
  EndIf
  $RegisteringClipboard = $OrigRegister
EndFunc

Func massdelete()
   local $od
   local $do
   $is_control = 1
   set_keys()
   $ClearQueue = 0
   $od = InputBox(show_mess(16),show_mess(17),"","",150,130)
	If @Error = 1 OR $od == "" Then 
      $is_control = 0
      set_keys()
      Return
   EndIf
   If number($od) < 1 OR number($od) > $maxclip+1 Then
      msgbox(4096,default,show_mess(18))
      $is_control = 0
      set_keys()
      Return
   EndIf
   $do = InputBox(show_mess(16),show_mess(19,$maxclip+1),"","",150,130)
	IF @Error = 1 OR $do == "" Then 
	   $is_control = 0
      set_keys()
      Return
   EndIf
   IF number($do) < number($od) OR number($do) > $maxclip+1 Then
      msgbox(4096,default,show_mess(20))
      $is_control = 0
      set_keys()
      Return
   EndIf
	 ; Arrary is indexed from 0
	 $od += -1 
	 $do += -1 
   DeleteClip($od,$do)
   If $cliplist[0][0] ="" And $showclip = 0 Then
      TraySetToolTip("Rclipstep.exe")
      ; If there is no clip, then show_list is not called and key is not returned back
   Else
      Tray_tool($showclip)
   EndIf
   $is_control = 0
   set_keys()
   If $is_preview = 0 Then
      show_list()
   EndIf
EndFunc

Func Move_Clip()
	local $new_pos
  $is_control = 1
  set_keys()
  $new_pos = InputBox(show_mess(26),show_mess(27,String_tool($showclip, $showlen,1),$showclip+1,$maxclip+1),"","",450,160)
	IF @Error = 1 OR $new_pos == "" OR $new_pos -1 = $showclip  OR _ 
  	$cliplist[$showclip][0] = $IdentBinary OR _ 
    $cliplist[$new_pos-1][0] = $IdentBinary THEN
    msgbox(4096,default,show_mess(18))
    $is_control = 0
    set_keys()
    Return
  ENDIF
  IF number($new_pos) < 1 OR number($new_pos) > $maxclip+1  THEN
  	msgbox(4096,default,show_mess(18))
    $is_control = 0
    set_keys()
    return
  ENDIF
  $new_pos = $new_pos-1
  If is_RO($showclip) Then
  	msgbox(4096,default,show_mess(42,$showclip+1))
  	Return
  EndIf
  If is_RO($new_pos) Then
  	msgbox(4096,default,show_mess(42,$new_pos+1))
  	Return
  EndIf
  If $cliplist[$new_pos][4] = "F" Then
	  MoveClipFile($showclip, $new_pos)
    ; DeleteClip($showclip,$showclip) This could lead to not transparency shift currently moved clip      
	  $cliplist[$new_pos][4] = ""
    $showclip=$new_pos
	ElseIf $cliplist[$showclip][4] = "F" Then
	  MoveClipFile($new_pos,$showclip)
    ; DeleteClip($new_pos,$new_pos)   This could lead to not transparency shift currently moved clip   
	  $cliplist[$showclip][4] = ""
  Else
    MoveClipFile($new_pos, $maxclip+1)
	  MoveClipFile($showclip, $new_pos)
	  MoveClipFile($maxclip+1, $showclip)
    $showclip=$new_pos
  EndIf
  $is_control = 0
  set_keys()
  Tray_tool($showclip)     
EndFunc

#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Storing clips to disk and reading from disk
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Func WriteToFile($clipnum, $StoreBmp = 0)
  $DebugProg="WriteToFile"
  Local $tmp, $myfile, $bmpfile, $bmpcontent, $FTime
  debug_write(0,@ScriptLineNumber&" - "&"Zapisuji cur="&$showclip&" $StoreBmp="&$StoreBmp&" D="&$DirExists&" cc="&$cliplist[$clipnum][0])
  If is_RO($clipnum) Or $cliplist[$clipnum][4] = "F" Then
    $tmp = $DirName&"\"&$clipnum+1&".log"
    If $cliplist[$clipnum][1]<>"" Then
      $myfile = FileOpen($tmp, 128+2)
      FileWrite($myfile,$cliplist[$clipnum][1])
      FileClose($myfile)
    Else
      FileRecycle($tmp)
    EndIf
  	Return
  EndIf
  If $DirExists = 1 then
	  $tmp = $DirName&"\"&$clipnum+1&".txt"
    $myfile = FileOpen($tmp, 128+2)
    If $myfile = -1 Then
      MsgBox(0, "WriteToFile", show_mess(10,$tmp)&" tmp="&$tmp)
      Return
    Else
      $tmp = $DirName&"\"&$clipnum+1&$BmpExt
      debug_write(0,@ScriptLineNumber&" - "&"Zapisuji bmp "&$clipnum&" store="&$StoreBmp)
      If is_bitmap($clipnum) Then
      	If (Not FileExists($tmp) Or $clipnum>=$LimitList-1) And $StoreBmp = 1 And $hbitmap > 0 Then
        	debug_write(0,@ScriptLineNumber&" - "&"Zapisuji bmp "&$clipnum&" $tmp="&$tmp)
          _ScreenCapture_SaveImage($tmp, $hbitmap, true)
        EndIf
        $bmpfile = FileOpen($tmp,16)
        If $bmpfile <> -1 Then         
        	$bmpcontent = FileRead($bmpfile)
          FileClose($bmpfile)
        	$cliplist[$clipnum][0]=StringMid($cliplist[$clipnum][0],1,StringInStr($cliplist[$clipnum][0],"--",2,2)+1)&_Crypt_HashData($bmpcontent,$CALG_MD5)
        EndIf
      Else
        FileRecycle($tmp)
      EndIf 
      debug_write(0,@ScriptLineNumber&" - "&"bmp s hash:"&$cliplist[$clipnum][0]&" clipnum="&$clipnum)
      FileWrite($myfile,$cliplist[$clipnum][0])
      FileClose($myfile)
      $tmp = $DirName&"\"&$clipnum+1&".log"
      If $cliplist[$clipnum][1]<>"" Then
        $myfile = FileOpen($tmp, 128+2)
        FileWrite($myfile,$cliplist[$clipnum][1])
        FileClose($myfile)
      Else
        FileRecycle($tmp)
      EndIf
    EndIf
  EndIf
	$FTime = @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC
	$cliplist[$clipnum][3] = $FTime
EndFunc

Func DeleteClipFile($clipnum)
	Local $tmp, $attr
  If $DirExists = 1 Then
 	  $tmp = $DirName&"\"&$clipnum+1&".txt"
    $attr = FileGetAttrib ( $tmp )
    If is_RO($clipnum) Then
       Return
    EndIf
    FileRecycle($tmp)
    If FileExists($tmp) Then
      MsgBox (4096,default,show_mess(39,$tmp))
      Exit
    EndIf
    $tmp = $DirName&"\"&$clipnum+1&$BmpExt
    FileRecycle($tmp)
    If FileExists($tmp) Then
      MsgBox (4096,default,show_mess(39,$tmp))
      Exit
    EndIf
    $tmp = $DirName&"\"&$clipnum+1&".log"
    FileRecycle($tmp)
    If FileExists($tmp) Then
      MsgBox (4096,default,show_mess(39,$tmp))
      Exit
    EndIf
	EndIf
  $cliplist[$clipnum][0] = ""
  $cliplist[$clipnum][1] = ""
  $cliplist[$clipnum][2] = ""
  $cliplist[$clipnum][3] = ""
  $cliplist[$clipnum][4] = "F"
  $cliplist[$clipnum][5] = ""
EndFunc

Func MoveClipFile($from, $to)
   local $tmpto, $tmpfrom
   If $DirExists = 1 Then
      ; txt file
      ; check if file to exists -> error
      If is_RO($from) Then
         msgbox(4096,default,show_mess(42,$from+1))
         Return
      EndIf
      If is_RO($to) Then
         msgbox(4096,default,show_mess(42,$to+1))
         Return
      EndIf
      $tmpto = $DirName&"\"&$to+1&".txt"
      If $cliplist[$to][4] = "F" Then
         FileDelete($tmpto)
      ElseIf FileExists($tmpto) Then
         MsgBox (4096,default,show_mess(39,$tmpto,@ScriptLineNumber))
         Exit
      EndIf
      ; Move file from -> to
      $tmpfrom = $DirName&"\"&$from+1&".txt"
      FileMove( $tmpfrom, $tmpto,1)
      ; Check if file from exists after move -> error
      If FileExists($tmpfrom) Then
         MsgBox (4096,default,show_mess(39,$tmpfrom,@ScriptLineNumber))
         Exit
      EndIf
      ; bmp file     
      $tmpto = $DirName&"\"&$to+1&$BmpExt
      If FileExists($tmpto) Then
         MsgBox (4096,default,show_mess(39,$tmpto,@ScriptLineNumber))
         Exit
      EndIf
      $tmpfrom = $DirName&"\"&$from+1&$BmpExt
      FileMove( $tmpfrom, $tmpto,1)      
      If FileExists($tmpfrom) Then
         MsgBox (4096,default,show_mess(39,$tmpfrom,@ScriptLineNumber))
         Exit
      EndIf
      ; log file
      $tmpto = $DirName&"\"&$to+1&".log"
      If FileExists($tmpto) Then
         MsgBox (4096,default,show_mess(39,$tmpto,@ScriptLineNumber))
         Exit
      EndIf
      $tmpfrom = $DirName&"\"&$from+1&".log"
      FileMove( $tmpfrom, $tmpto,1)      
      If FileExists($tmpfrom) Then
         MsgBox (4096,default,show_mess(39,$tmpfrom,@ScriptLineNumber))
         Exit
      EndIf
   Endif
   $cliplist[$to][0] = $cliplist[$from][0]
   $cliplist[$to][1] = $cliplist[$from][1]
   $cliplist[$to][2] = $cliplist[$from][2]
   $cliplist[$to][3] = $cliplist[$from][3]
   $cliplist[$to][4] = $cliplist[$from][4]
   $cliplist[$to][5] = $cliplist[$from][5]
   $cliplist[$from][0] = ""
   $cliplist[$from][1] = ""
   $cliplist[$from][2] = ""
   $cliplist[$from][3] = ""
   $cliplist[$from][4] = "F"
   $cliplist[$from][5] = ""
EndFunc

Func ReadDir ($Dir, $RO)
	$DebugProg="ReadDir"
  local $search, $Filename, $file, $file2, $retezec, $LTime, $FTime, $attr 
  If FileExists($Dir) Then
		$Filename = $Dir&"\*.txt"
    $search = FileFindFirstFile($Filename)  
     ; Check if the search was successful
    If $search = -1 Then
       debug_write(0,@ScriptLineNumber&" - "&"Nic nenalezeno - "&$search)
       Return
    EndIf
    While 1
      $file = FileFindNextFile($search) 
      If @error Then ExitLoop    
		$retezec = StringTrimRight($file,4) 
      debug_write(0,@ScriptLineNumber&" - "&"$File="&$file&" "&$retezec)
      If StringIsInt ($retezec) = 1 Then
         $curclip = number($retezec)-1
         If $curclip<=$LimitList-1 Then 
            If $curclip>= 0 then
               $Filename = $Dir&"\"&$file
               $file2 = FileOpen($Filename, 0)
               If $file2 = -1 Then
                  MsgBox(4096, Default,show_mess(11,$file))
                  $retezec =""
               Else
                  $retezec = FileRead($file2)
                  FileClose($file2)
                  debug_write(0,@ScriptLineNumber&" - "&$curclip&" "&$retezec)
                  If StringReplace(show_string($retezec)," ","") <> "" And $retezec <> $IdentBinary then
                     $cliplist[$curclip][0] = $retezec
                     $file2 = FileOpen($Dir&"\"&$curclip+1&".log", 0)
                     $cliplist[$curclip][1] = FileRead($file2)
                     FileClose($file2)
                     $LTime = FileGetTime($Filename, 0)
                     If Not @error Then
                        $FTime = $LTime[2] & "." & $LTime[1] & "." & $LTime[0] & " " & $LTime[3] & ":" & $LTime[4] & ":" & $LTime[5]
                     Else
                        $LTime = FileGetTime($DirName&"\"&$i+1&".log", 0)
                        If Not @error Then
                           $FTime = $LTime[2] & "." & $LTime[1] & "." & $LTime[0] & " " & $LTime[3] & ":" & $LTime[4] & ":" & $LTime[5]
                        Else
                           $FTime ="????"
                        EndIf
                     EndIf
                     $cliplist[$curclip][3] = $FTime
                     $attr = FileGetAttrib ( $Filename )
                     If $RO = "I" And StringInStr($attr,"H") = 0 Then
                        $cliplist[$curclip][4] = "I"
                     ElseIf $RO = "I" And StringInStr($attr,"H") > 0 Then
                        $cliplist[$curclip][4] = "O"
                     ElseIf StringInStr($attr,"R") > 0 And StringInStr($attr,"H") = 0 Then
                        $cliplist[$curclip][4] = "R"
                     ElseIf StringInStr($attr,"R") > 0 And StringInStr($attr,"H") > 0 Then
                        $cliplist[$curclip][4] = "O"
                     ElseIf StringInStr($attr,"R") = 0 And StringInStr($attr,"H") > 0 Then
                        $cliplist[$curclip][4] = "H"
                     Else
                        $cliplist[$curclip][4] = ""
                     EndIf
                     If $maxclip < $curclip then
                        $maxclip = $curclip   
                        $maxcurclip = $curclip                             
                     Endif
                  EndIf
               Endif
               debug_write(0,@ScriptLineNumber&" - "&$curclip+1&" - "&String_tool($curclip,50))
            Endif
         Endif
      Endif
		WEnd
  ; Close the search handle
  	FileClose($search)
   EndIf
   $curclip  = $maxclip
   $showclip = $maxclip
   debug_write(0,@ScriptLineNumber&" - "&"CurClip:"&$curclip&" ShowClip:"&$showclip&" maxclip:"&$maxclip&" maxcurclip:"&$maxcurclip)
EndFunc

Func ReadFromFile()
   $DebugProg="ReadFromFile"
   Local $OrigRegister
   $ClearBuff = 0
   $OrigRegister = $RegisteringClipboard
   If $DirExists = 1 Then
      $RegisteringClipboard = 0
      FOR $i = 0 To $LimitList-1
    		$cliplist[$i][0] = ""
    		$cliplist[$i][1] = ""
    		$cliplist[$i][2] = ""
    		$cliplist[$i][3] = ""
    		$cliplist[$i][4] = "F"
    		$cliplist[$i][5] = ""
  		NEXT
      debug_write(0,@ScriptLineNumber&" - Clear cliplist done "&"$LimitList="&$LimitList)
      ReadDir($DirName,"")
      $DebugProg="ReadFromFile"
      debug_write(0,@ScriptLineNumber&" - Read standard clips, "&"$maxclip="&$maxclip)
      ReadDir($IncludeDir,"I")
      $DebugProg="ReadFromFile"
      debug_write(0,@ScriptLineNumber&" - Read fixed clips, "&"$maxclip="&$maxclip)
      $curclip = $maxclip
      clip_put2 ($curclip)                                           
      $RegisteringClipboard = $OrigRegister
   EndIf
   $DebugProg="ReadFromFile"
   debug_write(0,@ScriptLineNumber&" - "&$curclip+1&" - "&String_tool($curclip,50))
EndFunc

Func cleardir()
	If $maxclip > 0 then
  	IF msgbox(1,Default,show_mess(12)) = 1 THEN
	  	DeleteClip (0,$maxclip)
     	refresh_clips()
   	ENDIF;
  ENDIF;
EndFunc

Func stopDir()
   If $DirName = "" Then
      NewQueue()
   ElseIf FileExists($DirName) = 1 THEN
      IF msgbox(1,Default,show_mess(13)) = 1 THEN	
         IF DirRemove($DirName, 1) = 1 THEN
            $DirExists = 0
            TrayItemSetState($stopdir,$TRAY_UNCHECKED)
            TrayItemSetState($refresh,$TRAY_DISABLE)
            TrayItemSetState($ManageDir,$TRAY_DISABLE)
            TrayItemSetState($ChangeDir,$TRAY_DISABLE)
         ELSE
            msgbox(4096,default,show_mess(14,$DirName))
            TrayItemSetState($stopdir,$TRAY_CHECKED)
            TrayItemSetState($refresh,$TRAY_ENABLE)
            TrayItemSetState($ManageDir,$TRAY_ENABLE)
            TrayItemSetState($ChangeDir,$TRAY_ENABLE)
         ENDIF
      ELSE
         TrayItemSetState($stopdir,$TRAY_CHECKED)
         TrayItemSetState($refresh,$TRAY_ENABLE)
         TrayItemSetState($ManageDir,$TRAY_ENABLE)
         TrayItemSetState($ChangeDir,$TRAY_ENABLE)
      ENDIF
   ELSE
      IF DirCreate($DirName) = 1 THEN 
         $DirExists = 1
         TrayItemSetState($stopdir,$TRAY_CHECKED)
         TrayItemSetState($refresh,$TRAY_ENABLE)
         TrayItemSetState($ManageDir,$TRAY_ENABLE)
         TrayItemSetState($ChangeDir,$TRAY_ENABLE)
         Local $i
         FOR $i = 0 To $maxclip
            WriteToFile($i)
         NEXT 
      ELSE
         msgbox(4096,default,show_mess(15),$DirName)
         TrayItemSetState($stopdir,$TRAY_UNCHECKED)
         TrayItemSetState($refresh,$TRAY_DISABLE)
         TrayItemSetState($ManageDir,$TRAY_DISABLE)
         TrayItemSetState($ChangeDir,$TRAY_DISABLE)
      ENDIF
   ENDIF
ENDFUNC

Func NewQueue($NewDir = "")
  $is_control = 1
  set_keys()
  $NewDir = InputBox(show_mess(24,$DirName),show_mess(24,$DirName),"","",150,130)
	IF @Error = 1 OR $NewDir == "" THEN RETURN 
  	IF FileExists($NewDir) = 1 THEN
		$DirName = $NewDir
    refresh_clips()
    TrayItemSetState($ManageDir,$TRAY_ENABLE)
    TrayItemSetState($ChangeDir,$TRAY_ENABLE)
  ELSE
    IF DirCreate($NewDir) = 1 THEN 
			$DirName = $NewDir
      $DirExists = 1
			refresh_clips()
      TrayItemSetState($stopdir,$TRAY_CHECKED)
      TrayItemSetState($refresh,$TRAY_ENABLE)
      TrayItemSetState($ManageDir,$TRAY_ENABLE)
      TrayItemSetState($ChangeDir,$TRAY_ENABLE)
    ELSE
      msgbox(4096,default,show_mess(15),$NewDir)
      TrayItemSetState($stopdir,$TRAY_UNCHECKED)
      TrayItemSetState($refresh,$TRAY_DISABLE)
      TrayItemSetState($ManageDir,$TRAY_DISABLE)
      TrayItemSetState($ChangeDir,$TRAY_DISABLE)
    ENDIF
	ENDIF
  $is_control = 0
  set_keys()
  TrayItemSetText ( $stopdir ,show_mess(0,$DirName))
	TrayItemSetText ( $ManageDir ,show_mess(25,$DirName))
ENDFUNC

Func refresh_clips()
   TrayItemSetState($showcopy,$TRAY_CHECKED)
   $RegisteringClipboard = 0
   $curclip  = 0
   $showclip = 0
   $maxclip = 0
   $maxcurclip = 0
   Local $i
   clip_put ("")
   If FileExists($DirName) Then
      $DirExists = 1
      debug_write(0,@ScriptLineNumber&" - "&"clip="&$showclip+1&" curclip="&$curclip+1,"refresh_clips")
      ReadFromFile()
      debug_write(0,@ScriptLineNumber&" - "&"clip="&$showclip+1&" curclip="&$curclip+1,"refresh_clips")
      TrayItemSetState($stopdir,$TRAY_CHECKED)            
   else
      $DirExists = 0
      TrayItemSetState($stopdir,$TRAY_UNCHECKED)
   EndIf
   $i = -1
   init_viewer()
   If $cliplist[0][4] ="F" And $showclip = 0 Then
      TraySetToolTip("Rclipstep.exe")
   Else
      Tray_tool($showclip)
   EndIf   
EndFunc

#cs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Auxiliary function, initialisation
#ce %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Func Escape()
   ; Allow terminate script during inserting clip by paste_special
   IF msgbox(1,Default,show_mess(28)) = 1 THEN
      Exit
   EndIf
EndFunc

Func register_viewer()
  Local $OrigRegister
  $OrigRegister = $RegisteringClipboard
	$RegisteringClipboard = 0
  debug_write(0,@ScriptLineNumber&" Start - "&"$ClipNext="&$ClipNext&" $ClipHandler"&$ClipHandler&" viewer="&_ClipBoard_GetViewer()&" $RegisteringClipboard="&$RegisteringClipboard,"register_viewer")
  If $ClipHandler <> 0 Then
  	_ClipBoard_ChangeChain ($ClipHandler, $ClipNext)
  	GUIDelete($ClipHandler)
  EndIf
  $ClipHandler = GUICreate("Rclipstep", 0, 0)
	;GUIRegisterMsg(0x030D, "WM_CHANGECBCHAIN")
 	;GUIRegisterMsg(0x0308, "WM_DRAWCLIPBOARD")
  $ClipNext = _ClipBoard_SetViewer ($ClipHandler)
 	GUIRegisterMsg($WM_CHANGECBCHAIN, "WM_CHANGECBCHAIN")
 	GUIRegisterMsg($WM_DRAWCLIPBOARD, "WM_DRAWCLIPBOARD")
  $RegisteringClipboard = $OrigRegister
 	debug_write(0,@ScriptLineNumber&" register - "&"$ClipNext="&$ClipNext&" $ClipHandler"&$ClipHandler&" viewer="&_ClipBoard_GetViewer(),"register_viewer")
EndFunc

Func Cleanup()
  ; Shut down clipboard viewer
  debug_write(0,@ScriptLineNumber&" Start - "&"$ClipNext="&$ClipNext&" $ClipHandler="&$ClipHandler,"Cleanup")
  GUIRegisterMsg($WM_DRAWCLIPBOARD, "")
  GUIRegisterMsg($WM_CHANGECBCHAIN, "")
  _ClipBoard_ChangeChain ($ClipHandler, $ClipNext)
  GUIDelete($ClipHandler)
  DllClose($dll)
  $ClipHandler = 0
  $ClipNext = 0
  debug_write(0,@ScriptLineNumber&" End - "&"$ClipNext="&$ClipNext&" $ClipHandler="&$ClipHandler,"Cleanup")
EndFunc

Func is_bitmap($clip = $curclip)
  If StringInStr($cliplist[$clip][0],$IdentBitmap,1) = 1 Then
  	Return True
  Else
  	Return False
  EndIf
EndFunc

Func is_RO($clip = $curclip)
  If $cliplist[$clip][4] = "R" Or $cliplist[$clip][4] = "I" Or $cliplist[$clip][4] = "O"  Then
  	Return True
  Else
  	Return False
  EndIf
EndFunc

Func is_H($clip = $curclip)
  If $cliplist[$clip][4] = "H" Or $cliplist[$clip][4] = "O"  Then
  	Return True
  Else
  	Return False
  EndIf
EndFunc

Func Name_Clip()
  local $new_text
  If $cliplist[$showclip][4] = "F" Then Return
  $is_control = 1
  set_keys()
  $new_text = InputBox(show_mess(30,""),show_mess(30,String_tool($showclip, -200)),$cliplist[$showclip][1],"",450,160)
	IF @Error = 1 THEN 
  	$is_control = 0
    set_keys()
    Return
  EndIf
	IF $new_text == $cliplist[$showclip][1] THEN
  	$is_control = 0
    set_keys()
    Return
  EndIf 
  $cliplist[$showclip][1]=$new_text
  WriteToFile($showclip)
  $is_control = 0
  set_keys()
EndFunc

Func Set_RO($item)
   local $attr, $tmp
   $tmp = $DirName&"\"&$item+1&".txt"
   debug_write(0,@ScriptLineNumber&" - Attribut is "&$cliplist[$item][4]&" and has been set for "&$tmp,"Set_RO")
   If FileExists($tmp) And $cliplist[$item][4] <> "I" Then
      If $cliplist[$item][4] = "R" Then
         $attr = FileSetAttrib ($tmp, "-R" )
         $cliplist[$item][4] = ""
      ElseIf $cliplist[$item][4] = "O" Then
         $attr = FileSetAttrib ($tmp, "-R" )
         $cliplist[$item][4] = "H"
      ElseIf $cliplist[$item][4] = "H" Then
         $attr = FileSetAttrib ($tmp, "+R" )
         $cliplist[$item][4] = "O"
      Else
         $attr = FileSetAttrib ($tmp, "+R" )
         $cliplist[$item][4] = "R"
      EndIf
      debug_write(0,@ScriptLineNumber&" - Attribut is "&$cliplist[$item][4]&" and has been set for "&$tmp,"Set_RO")
   Else
      debug_write(0,@ScriptLineNumber&" - File not exists:"&$tmp,"Set_RO")
   EndIf
EndFunc

Func Set_H($item)
   local $attr, $tmp
   $tmp = $DirName&"\"&$item+1&".txt"
   debug_write(0,@ScriptLineNumber&" - Attribut is "&$cliplist[$item][4]&" and has been set for "&$tmp,"Set_H")
   If FileExists($tmp) And $cliplist[$item][4] <> "I" Then
		If $cliplist[$item][4] = "H" Then
         $attr = FileSetAttrib ($tmp, "-H" )
         $cliplist[$item][4] = ""
      ElseIf $cliplist[$item][4] = "O" Then
         $attr = FileSetAttrib ($tmp, "-H" )
         $cliplist[$item][4] = "R"
      ElseIf $cliplist[$item][4] = "R" Then
         $attr = FileSetAttrib ($tmp, "+H" )
         $cliplist[$item][4] = "O"
      Else
         $attr = FileSetAttrib ($tmp, "+H" )
         $cliplist[$item][4] = "H"
      EndIf
      debug_write(0,@ScriptLineNumber&" - Attribut has been set for "&$tmp,"Set_H")
   Else
      debug_write(0,@ScriptLineNumber&" - File not exists:"&$tmp,"Set_H")
   EndIf
EndFunc

Func massRO()
  local $od
  local $do
  $is_control = 1
  set_keys()
  $od = InputBox(show_mess(44),show_mess(17),"","",150,130)
	If @Error = 1 OR $od == "" Then 
    $is_control = 0
    set_keys()
    Return
  EndIf
  If number($od) < 1 OR number($od) > $maxclip+1 Then
    msgbox(4096,default,show_mess(18))
    $is_control = 0
    set_keys()
  	Return
  EndIf
  $do = InputBox(show_mess(44),show_mess(19,$maxclip+1),"","",150,130)
	IF @Error = 1 OR $do == "" Then 
	  $is_control = 0
    set_keys()
  	Return
  EndIf
  IF number($do) < number($od) OR number($do) > $maxclip+1 Then
    msgbox(4096,default,show_mess(20))
    $is_control = 0
    set_keys()
  	Return
  EndIf
	; Arrary is indexed from 0
	$od += -1 
  $do += -1
	While $od <= $do
		If $cliplist[$od][4] <> "F" Then
         set_RO($od)
		EndIf
		$od += 1
  WEnd
  If $cliplist[0][0] ="" And $showclip = 0 Then
  	TraySetToolTip("Rclipstep.exe")
    ; If there is no clip, then show_list is not called and key is not returned back
  Else
  	Tray_tool($showclip)
  EndIf
  $is_control = 0
  set_keys()
EndFunc

Func input_box($winname, $text)
   Local $hGUI, $hEdit, $edittext, $msg, $Button_OK, $Button_Cancel, $Styles
   ; Create GUI
   $hGUI = GUICreate($winname, 400, 310)
   $is_control = 1
   set_keys()
   $Styles = BitOR($ES_MULTILINE, $ES_WANTRETURN, $WS_VSCROLL, $WS_HSCROLL, $ES_AUTOVSCROLL, $ES_AUTOHSCROLL)
   If $is_setv = 1 Then
      $Styles = BitOR($Styles,$ES_READONLY)
      $hEdit = _GUICtrlEdit_Create($hGUI, $text, 1, 1, 385, 268, $Styles)
      $Button_OK = GUICtrlCreateButton(show_mess(53), 100, 277) ; OK
      $Button_Cancel = GUICtrlCreateButton("", 210, 277, 1, 1)  ; Cancel
   Else
      $hEdit = _GUICtrlEdit_Create($hGUI, $text, 1, 1, 385, 268, $Styles)
      $Button_OK = GUICtrlCreateButton(show_mess(35), 100, 277) ; OK
      $Button_Cancel = GUICtrlCreateButton(show_mess(36), 210, 277)  ; Cancel 
   EndIf
   WinActivate ($hGUI)
   GUISetState()
   Send ("^{HOME}")
   $edittext = "" 
   ; Loop until user exits
   While 1
      $msg = GUIGetMsg()
      Select
         Case $msg = $GUI_EVENT_CLOSE
            $edittext = _GUICtrlEdit_GetText($hEdit)
            ExitLoop
         Case $msg = $Button_OK
            If $is_setv = 0 Then $edittext = _GUICtrlEdit_GetText($hEdit)
            ExitLoop
         Case $msg = $Button_Cancel
            ExitLoop
         Case NOT _IsPressed("11",$dll) AND $is_setv = 1 
            ExitLoop
         Case $is_control = 2
            ExitLoop
      EndSelect
   WEnd
   GUIDelete($hGUI)
   $is_control = 0
   set_keys()
   Return $edittext
EndFunc   ;==>_Example1

Func ReWriteClip($lineno = $showclip)
   local $new_text, $OrigRegister
   $OrigRegister = $RegisteringClipboard
   ;   $new_text = InputBox(show_mess(31,""),show_mess(31,$showclip+1),$cliplist[$showclip][0],"",450,160)
   $RegisteringClipboard = 0
   If $is_setv = 1 Then
      $new_text = Input_Box(show_mess(52,$lineno+1),$cliplist[$lineno][0])
   Else
      $new_text = Input_Box(show_mess(31,$lineno+1),$cliplist[$lineno][0])
   EndIf
	IF @Error = 1 OR $new_text == "" THEN RETURN 
	IF $cliplist[$lineno][0] == $new_text THEN RETURN 
   $cliplist[$lineno][0]=$new_text
   If $cliplist[$lineno][4] = "F" Then
      $cliplist[$lineno][4] = ""
   EndIf
	If $lineno = $curclip Then
     Clip_put($new_text)
   EndIf
   WriteToFile($lineno)
   $RegisteringClipboard = $OrigRegister
   Tray_tool($showclip)
EndFunc

Func Find_Clip()
   $DebugProg="Find_Clip"
   local $new_text, $i=0, $found = 0
   $is_control = 1
   set_keys()
   $new_text = InputBox(show_mess(34,""),show_mess(34),"","",450,160)
	IF @Error = 1 OR $new_text == "" THEN 
      $is_control = 0
      set_keys()
      Return
   EndIf 
   WHILE $i<= $maxclip
      If $cliplist[$i][4] <> "F" Then 
         $cliplist[$i][2] = ""
         If Not is_bitmap($i) And $cliplist[$i][0]<> $IdentBinary Then
            If StringInStr($cliplist[$i][0], $new_text, 2)>0 Then
               $cliplist[$i][2] = "C"
               $found = $found + 1
               $showclip = $i 
            EndIf
         EndIf
         debug_write(0,@ScriptLineNumber&" - "&"$clio="&$cliplist[$i][1]&" $new_text="&$new_text&" $i="&$i)
         If StringInStr($cliplist[$i][1], $new_text, 2)>0 Then
            $cliplist[$i][2] = "N"
            $found = $found + 1
            $showclip = $i 
         EndIf
      EndIf
      $i +=1
   Wend
   $InitSort = 5
   $is_control = 0
   set_keys()
   If $found > 0  Then
      If $RestartView = 0 Then
         show_list()
      EndIf
   Else
      MsgBox (4096,default,show_mess(37))
   EndIf
EndFunc

Func Clip_put($clip)
  $DebugProg="Clip_put"
  ;Local $i 
  clipput($clip)
  ;$i=_ClipBoard_SetData($clip,$CF_UNICODETEXT)  
  ;If $i = 0 Then
  ;   debug_write(0,@ScriptLineNumber&" - "&"Unable to set data "&StringLeft($clip,20)&", cur clip="&StringLeft(_ClipBoard_GetData($CF_TEXT),20))
  ;EndIf
EndFunc

Func Clip_put2($clip)
  If is_bitmap($clip) Then
  	Retrieve_bitmap($curclip)
  Else
  	clip_put ($cliplist[$curclip][0])
  EndIf
EndFunc

Func file_bitmap ($clip)
  Local $fname
  If FileExists($IncludeDir&"\"&$clip+1&$BmpExt) Then
  	$fname = $IncludeDir&"\"&$clip+1&$BmpExt
  ElseIf FileExists($DirName&"\"&$clip+1&$BmpExt) Then
  	$fname = $DirName&"\"&$clip+1&$BmpExt
  Else
  	$fname = ""
  EndIf
  Return $fname 
EndFunc

Func Retrieve_bitmap($clip)
  $DebugProg=""
  Local $hImage, $hBmp, $hBitmap, $fname
  $fname = file_bitmap ($clip)
  debug_write(0,@ScriptLineNumber&" - "&"$clip="&$clip&" $fname="&$fname&" $showclip="&$showclip)
  If $fname <> "" Then
  	_GDIPlus_Startup ()
    $hImage = _GDIPlus_ImageLoadFromFile($fname)
    If $hImage <> -1 Then
    	$hBmp = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
      $hBitmap = _WinAPI_CopyImage($hBmp)
      If _ClipBoard_Open(0) Then
      	_ClipBoard_Empty()
        _ClipBoard_SetDataEx($hBitmap, $CF_BITMAP)
        _ClipBoard_Close()
      EndIf
      _WinAPI_DeleteObject($hBmp) 
      _GDIPlus_ImageDispose($hImage)
    EndIf
    _GDIPlus_Shutdown()
  EndIf
  debug_write(0,@ScriptLineNumber&" - "&"$clip="&$clip&" $fname="&$fname&" $showclip="&$showclip)
EndFunc

Func Clip_get($StoreBmp = 0)
	$DebugProg="Clip_get"
  Local $Clip, $BoardOwner=0, $error, $Format
	; 49428 =  HTML, 50083 = CSV
  Local $aFormats[8] = [7, $CF_UNICODETEXT, $CF_TEXT, $CF_OEMTEXT, $CF_DSPTEXT, 49428, 50083, $CF_BITMAP]
  $Format = _ClipBoard_GetPriorityFormat($aFormats)
 	debug_write(0,@ScriptLineNumber&" - "&" Format="&$Format&" Clipboard open window .: " & _ClipBoard_GetOpenWindow ())
  If $Format>0 Then
		If $Format<>$CF_BITMAP Then
  	  $clip=_ClipBoard_GetData($Format)
  	  $error = @error
  	  debug_write(0,@ScriptLineNumber&" - "&"clip="&$clip&" err="&$error)
		EndIf
	  If $Format=$CF_BITMAP Then
	  	debug_write(0,@ScriptLineNumber&" - "&"clip="&$clip&" err="&$error&" $StoreBmp="&$StoreBmp _
				&" Format="&$Format)
	  	If $StoreBmp = 1 And $StoreBitmap = 1 And $DirExists = 1 _
	    		AND $Format = $CF_BITMAP Then
	    	$BoardOwner=_ClipBoard_GetOwner()
	      If _ClipBoard_Open ($BoardOwner) Then
	        $closeClipboard = 1
	      	$hbitmap = _ClipBoard_GetDataEx($CF_BITMAP)
	      	$error = @error
					If $error = 0 Then 
					  If $hbitmap <> 0 Then
	        		$Clip = $IdentBitmap&@mday&"."&@mon&"."&@year&"  "&@hour&":"&@min&":"&@sec&"."&@msec&" --"
	        	Else
	        		SetError($error)
	        	EndIf
	     		Else
	     			SetError(-2)
  	  			$error = -2
	     	  	$Clip = $IdentBinary
	        	debug_write(0,@ScriptLineNumber&" - "&"_ClipBoard_Open failed for "&$BoardOwner&" err="&@error)
					EndIf
	     	Else
	     		SetError(-3)
 	  			$error = -3
	     	  $Clip = $IdentBinary
	        debug_write(0,@ScriptLineNumber&" - "&"_ClipBoard_Open failed for "&$BoardOwner&" err="&@error)
	     	EndIf
	    Else
     		SetError(-4)
			  $error = -4
	    	$Clip = $IdentBinary
	    EndIf
	  EndIf
		If $error <> 0 Then
    	$Clip = $IdentBinary
    EndIf
	Else
 		SetError(-5)
  	$Clip = $IdentBinary
  EndIf
	$error = @error
  debug_write(0,@ScriptLineNumber&" - "&"ret="&$Clip&" err="&$error)
	SetError($error)
 	Return $Clip
EndFunc

Func show_string($input)
	local $tmp
	$tmp = StringLeft($input, 120)
	$tmp = StringStripCR($tmp)
	$tmp = StringReplace($tmp,Chr(10)," ")
	$tmp = StringReplace($tmp,Chr(9)," ")
  Return ($tmp)
EndFunc

Func String_tool ($clip, $Len, $trunc = 0)
  Local $ret
  debug_write(0,@ScriptLineNumber&" - "&"clip="&$clip+1,"String_tool")
  If $cliplist[$clip][1] <> "" Then
    If is_H($clip) Then
      $ret = $clip+1 & " - "&"****** - "&$cliplist[$clip][1]
    Else
      If $Len < 0 Then
    	  $ret = StringLeft($cliplist[$clip][0], abs($Len)-23)&" - "&$cliplist[$clip][1]
        If $trunc = 1 Then $ret = show_string($ret)
        $ret = StringLeft($clip+1 & " - "&$ret,abs($Len))
      Else
        $ret = StringLeft($cliplist[$clip][0], abs($Len)-23)&chr(9)&$cliplist[$clip][1]
        If $trunc = 1 Then $ret = show_string($ret)
        $ret = StringLeft($clip+1&chr(9)&$ret,$Len)
      EndIf
    EndIf
  Else
    If is_H($clip) Then
      $ret = $clip+1 & " - "&"******"
    Else
  	  $ret = StringLeft($cliplist[$clip][0], abs($Len))
      If $trunc = 1 Then $ret = show_string($ret)
      If $Len < 0 Then
    	  $ret = StringLeft($clip+1&" - "&$ret,abs($Len))
      Else
    	  $ret = StringLeft($clip+1&chr(9)&$ret,$Len)
      EndIf
    EndIf
  EndIf
  Return $ret
EndFunc

Func Tray_tool($clip)
  If is_bitmap($clip) Or $cliplist[$clip][0] ==  $IdentBinary Then
     TrayItemSetState($ReWriteClip,$TRAY_DISABLE)
  Else
     TrayItemSetState($ReWriteClip,$TRAY_ENABLE)
  EndIf
  If is_H ($clip) Then
    TraySetToolTip(StringLeft("****** - "&$cliplist[$clip][1],50))
  Else
    TraySetToolTip(String_tool($clip, -50,1))
  EndIf
EndFunc

Func debug_write($show,$msg,$Prog = $DebugProg)
   Local $myfile
   If $show > 0 Then
     If $DebugScreen = 1 Or $show = 2 Then
        MsgBox(4096, $Prog, $Prog&":"&$msg)   
     EndIf
     If $DebugFile <> "" Then
       $myfile = FileOpen($DirName&"\"&$DebugFile, 128+1)
       FileWrite($myfile,$Prog&":"&$msg& @LF)
       FileClose($myfile)
     EndIf
   EndIf
EndFunc

Func Init()
   $DebugProg="Init"
   Local $i, $list
   Local $file, $buff, $pos, $variable, $value
   ; Check if same instance exists
   $list = ProcessList("RClipStep.exe")
   debug_write(0,@ScriptLineNumber&" - "&"list 1 = "&$list[0][0])
   $i = $list[0][0]
   $list = ProcessList("RClipStep_64.exe")
   debug_write(0,@ScriptLineNumber&" - "&"list 2 = "&$list[0][0])
   $i = $i + $list[0][0]
   IF $i > 1 THEN Exit
   Cleanup()
   $dll = DllOpen("user32.dll")
   ; Initialize clipboard viewer
   $curclip  = 0
   $showclip = 0
   $maxclip = 0
   $maxcurclip = 0
   $ClearBuff = 0
   $BeepDuration = 0
   $BeepFrequency = 500
   $StoreBitmap = 1
   $numclip = 0
   $showcopy_y = 1
	$store_clip=1
   $ToolWidth = 0
   $ToolHeight = 0
   $iQuality = 100
   $SUPasteDelay=500
   $DebugFile = ""
   $DebugScreen = 0
   $AutoDestroyPreview = 0
	$AllowDuplicity = 1
	$AutoClearQueue = 0
	$ClearQueue = 0
	$InitSort = 0
   ; max of translated message without about dialog
   ; = index of last message +1 (index start with 0)
   $maxmsg = 61
   ;maxabout - how helps are added, last msg[]  = $maxmsg + $maxabout 
   $maxabout = 24
   Global $msg[$maxmsg+1+$maxabout]
   $msg[0] = "Ukládání na disk do fronty [1]"
   $msg[1] = "Přehled klipů"
   $msg[2] = "Uložit clip při Ctrl-C" 
   $msg[3] = "Smazání vybraných klipů"
   $msg[4] = "Smazání všech klipů"
   $msg[5] = "Obnovení klipů z disku"
   $msg[6] = "Nápověda / O aplikaci"
   $msg[7] = "Exit"
   $msg[8] = "Konec bez vložení klipu"
   $msg[9] = "Smazání klipů od [1] do [2]"
   $msg[10] = "Nelze otevřít soubor [1] pro zápis"
   $msg[11] ="Nemohu číst soubor  [1]"
   $msg[12] ="Opravdu chcete nevratně smazat všechny klipy z paměti i z disku?"
   $msg[13] ="Opravdu chcete nevratně smazat všechny klipy z disku a zastavit jejich ukládání (v paměti zůstanou)?"
   $msg[14] ="Chyba rušení adresáře [1] - nelze zastavit ukládání klipů na disk"
   $msg[15] ="Nelze vytvořit adresář [1] - nelze ukládat klipy na disk"
   $msg[16] ="Mazaní klipů"
   $msg[17] ="Číslo prvního klipu"
   $msg[18] ="Počáteční klip je mimo smysluplný rozsah"
   $msg[19] ="Číslo posledního klipu - maximálně [1]"
   $msg[20] ="Konečný klip je mimo smysluplný rozsah"
   $msg[21] ="Přehled klipů"
   $msg[22] ="Ukládaní klipů do paměti"
   $msg[23] ="Změna fronty"
   $msg[24] ="Fronta je [1], zadejte nové jméno:"
   $msg[25] ="Správa fronty [1]"
   $msg[26] ="Změna čísla klipu"
   $msg[27] ="Pro klip [2] zadej novou pozici klipu (mezi 1 a [3])\n[1]"
   $msg[28] ="Stisknut ESC, chcete ukončit program?"
   $msg[29] = "Smazání klipu [1]"
   $msg[30] = "Přiřadit jméno clipu [1]"
   $msg[31] = "Změnit klip [1]"
   $msg[32] = "Číslo"
   $msg[33] = "Obsah klipu"
   $msg[34] = "Hledat klip"
   $msg[35] = "OK"
   $msg[36] = "Storno"
   $msg[37] = "Nenalezen žádný klip"
   $msg[38] = "Jméno klipu"
   $msg[39] = "Interní chyba (práce se souborem [1] - [2]), nutný restart"
   $msg[40] = "režim vkládání klipu"
   $msg[41] = "Datum změny"
   $msg[42] = "Klip [1] je chráněn proti změnám, operaci nelze provést"
   $msg[43] = "Menu"   
   $msg[44] = "Nastav příznak RO"
   $msg[45] = "Odstraň příznak RO"
   $msg[46] = "Schránka"
   $msg[47] = "Na velká písmena - Ctvr-v-u"
   $msg[48] = "Na malá písmena - Ctvr-v-l"
   $msg[49] = "Na prostý text - Ctvr-v-t"
   $msg[50] = "Expandovat síťovou cestu - Ctvr-v-n"
   $msg[51] = "Zavřít okno s náhledem"
   $msg[52] = "Zobrazit klip [1]"
   $msg[53] = "Zpět na vkládání klipu"
   $msg[54] = "Dosažen limit počtu klipů v frontě"
   $msg[55] = "Skryt klip"
   $msg[56] = "Odkrýt klip"
   $msg[57] = "Třídit dle čísla klipu"
   $msg[58] = "Třídít dle textu klipu"
   $msg[59] = "Třídít dle názvu klipu"
   $msg[60] = "Třídít dle datumu vzniku"
   $msg[61] = "Třídím..."
   
   $msg[$maxmsg+1]= "Základní funkčnost je na Ctrl-V, pak při držení klávesy Ctrl je možné:"
   $msg[$maxmsg+2]= "   -- Klávesou V (šipka dolů) listovat klipy dozadu" 
   $msg[$maxmsg+3]= "   -- Klávesou C (šipka nahoru) listovat klipy dopředu" 
   $msg[$maxmsg+4]= "   -- Klávesou X opustit aplikace bez vložení klipu, smazat aktualní klip, vyvolat přehled klipů či přesunout aktuální klip na jinou pozici." 
   $msg[$maxmsg+5]= "   -- Klávesou T převést klip na prostý text" 
   $msg[$maxmsg+6]= "   -- Klávesou U převést na velká písmena, L na malá písmena" 
   $msg[$maxmsg+7]= "   -- Klávesou F zobrazit přehled klipů, viz popis níže"
   $msg[$maxmsg+8]= "   -- Klávesou B zobrazit/Editovat klip nebo obrázek" 
   $msg[$maxmsg+9]= "   -- Číslo - skok přímo na vybraný klip dle čísla" 

   $msg[$maxmsg+10]= ""
   $msg[$maxmsg+11]= "Další důležité funčnosti jsou na pravé tlačítko myši nad ikonou RClipStepu v liště."
   $msg[$maxmsg+12]= "Tam lze zapnout či vypnou ukládání klipů na disk, vymazat všechny klipy (i z disku), znovu načíst klipy"
   $msg[$maxmsg+13]= "Klipy jsou uloženy v adresáři Clips, jsou to prosté textové soubory a obrázky, je možné je normálně editovat."
   $msg[$maxmsg+14]= "Změna se projeví až po restartu nebo po obnově klipů z disku"
   $msg[$maxmsg+15]= "Klipy lze ukládat do různých front a pak mezi nimy přepínat."
   $msg[$maxmsg+16]= "Pro práci s klipy je základní okno přehledu klipů, kde jsou tlačítka pro práci s klipy."
   $msg[$maxmsg+17]= "        V přehledu klipů fungují následující klávesové zkratky:"
   $msg[$maxmsg+18]= "         -- Klávesou Ctrl-V, Ctrl-C, Ctrl-X lze ukončit okno přehledu" 
   $msg[$maxmsg+19]= "         -- šipkami, klávesami Page Down, Page Up se můžete posouvat po klipech"
    
   $msg[$maxmsg+20]= "         -- Klávesou Enter editovat/prohlížet klip, obrázek" 
   $msg[$maxmsg+21]= "         -- Klávesou delete smazat aktualní klip" 
   $msg[$maxmsg+22]= "Překlad a inicializace je uložena v souboru rclipstep.ini."
   $msg[$maxmsg+23]= " Pro český jazyk smažte sekci 2 a 3, pro defaultní nastavení smažte celý soubor"
   $msg[$maxmsg+24]= "Nastavení - limit počtu klipů je [1], dosud použito [2] "
   
   $IncludeDir = ""
   FOR $i = 0 To $LimitList-1
      $IncompProg[$i] = ""
      $IncompProgType[$i] = ""
      $IncompProgAction[$i] = ""
   NEXT
   If FileExists("rclipstep.ini") Then
      $file = FileOpen("rclipstep.ini", 0)
      $i = 0
      While 1
         $buff = FileReadLine($file)
         If @error = -1 Then ExitLoop
         $pos = StringInStr($buff,"=")
         Select
            Case StringLeft($buff,1) = ";"
             	  ; Comment, null action
               $i = $i
            Case StringLeft($buff,1) = "$" AND $pos >0
               $pos = StringInStr($buff,"=")
               $variable = StringReplace(StringLower(StringMid($buff,2,$pos-2))," ","")
               debug_write(0,@ScriptLineNumber&" - "&$buff&" Instr="&StringInStr($buff,'"'))               
               If StringInStr($buff,'"')>0 Then
                  $value = StringMid($buff,StringInStr($buff,'"'))
                  $value = StringReplace($value,'"',"")
                  debug_write(0,@ScriptLineNumber&" - "&$buff&" - "&$value)
     				Else
                  $value = StringReplace(StringMid($buff,$pos+1)," ","") 
                  debug_write(0,@ScriptLineNumber&" - "&$buff&" - "&$value)
     				EndIf
           		Select
                  Case $variable="dirname"
                     If NOT Assign("variable",$value,4) Then
                        msgbox(4096,default,"Error in rclipstep.ini -  "&$buff)
                     EndIf
                     If $variable<>$InitDirName Then
                        $InitDirName = $variable
                        $DirName = $variable                  
                        If $DirName="" Then
                           $DirExists = 0
                           TrayItemSetState($stopdir,$TRAY_UNCHECKED)
                           TrayItemSetState($refresh,$TRAY_DISABLE)
                           TrayItemSetState($ManageDir,$TRAY_DISABLE)
                           TrayItemSetState($ChangeDir,$TRAY_DISABLE)
                        EndIf  
                     EndIf
                  Case  $variable="limitlist"
                     If NOT Assign($variable,$value,4) Then
                 	      msgbox(4096,default,"Error in rclipstep.ini -  "&$buff)
                     EndIf
                     Global $cliplist[$LimitList+1][3]                     
                     Global $IncompProg[$LimitList]
                     Global $IncompProgType[$LimitList]
                     Global $IncompProgAction[$LimitList]
                  Case  $variable="showtime" OR $variable="toolwidth" Or $variable="autodestroypreview" Or $variable="allowduplicity"
                     If NOT Assign($variable,$value,4) Then
                 	      msgbox(4096,default,"Error in rclipstep.ini -  "&$buff)
                     EndIf
                  Case $variable="showlen" OR $variable="includedir" OR $variable="toolheight" OR $variable="autoclearqueue"  
                     If NOT Assign($variable,$value,4) Then
                 	      msgbox(4096,default,"Error in rclipstep.ini -  "&$buff)
                     EndIf
                  Case $variable="beepduration" OR $variable="beepfrequency" OR $variable="storetime" _
                        OR $variable="storebitmap" OR $variable="iquality"  Or $variable="imageheight" Or $variable="imagewidth" _
                        OR $variable= "supastedelay" OR $variable= "debugfile" OR $variable= "debugscreen"  OR $variable= "exitkey"
                     If NOT Assign($variable,$value,4) Then
                        msgbox(4096,default,"Error in rclipstep.ini -  "&$buff)
                     EndIf
                  Case $variable="showcopy_y" OR $variable="bmpext" OR $variable="bitmapeditor" OR $variable="texteditor" _
                        OR $variable="bgcolornormal" OR $variable="bgcolorinsert" OR $variable="initsort"  
                     If NOT Assign($variable,$value,4) Then
                 	      msgbox(4096,default,"Error in rclipstep.ini -  "&$buff)
                     EndIf                     
                  Case StringInStr($variable,"incompprog[")>0
        					$pos = StringInStr($buff,"[")
                     $variable=StringMid($buff,$pos+1)   
        					$pos = StringInStr($variable,"]")
        					$variable=StringLeft($variable,$pos-1)
        					;remove "
        					$IncompProg[$variable]=StringLower($value)
                  Case StringInStr($variable,"incompprogtype[")>0
                     $pos = StringInStr($buff,"[")
                     $variable=StringMid($buff,$pos+1)   
                     $pos = StringInStr($variable,"]")
                     $variable=StringLeft($variable,$pos-1)
        				   ;remove "
                     $IncompProgType[$variable]=StringLower($value)   
                  Case StringInStr($variable,"incompprogaction[")>0
                     $pos = StringInStr($buff,"[")
                     $variable=StringMid($buff,$pos+1)   
                     $pos = StringInStr($variable,"]")
                     $variable=StringLeft($variable,$pos-1)
        				   ;remove "
                     $IncompProgAction[$variable]=$value   
                  Case $variable="store_clip"
                     If NOT Assign($variable,$value,4) Then
                 	      msgbox(4096,default,"Error in rclipstep.ini -  "&$buff)
                     Else
                        if $store_clip=0 then
                           TrayItemSetState($storeitem,$TRAY_UNCHECKED)
                        else
                           TrayItemSetState($storeitem,$TRAY_CHECKED)
        						endif        
        					EndIf    
                  Case Else
               	  msgbox(4096,default,"Error in rclipstep.ini - "&$variable&" is not declared")
         		EndSelect
            Case Else
               $msg[$i] = $buff
               $i += 1
               debug_write(0,@ScriptLineNumber&" - "&"$i = "&$i&" buff="&$buff)
         EndSelect
      Wend
      FileClose($file)
      debug_write(0,@ScriptLineNumber&" - "&"End - $i = "&$i)
      If $i > 0 Then
         If $i > $maxmsg Then
            $maxabout = $i - $maxmsg-1
         Else
            $maxabout = 0
         EndIf
      EndIf
   EndIf
   If NOT ($BmpExt = ".bmp" OR $BmpExt = ".gif" OR $BmpExt = ".jpg" OR $BmpExt = ".png" OR $BmpExt = ".tif" ) Then
      msgbox(4096,default,"Error in rclipstep.ini - $BmpExt="&$BmpExt&" is not bitmap format known by rclipstep, .png will be used")
      $BmpExt=".png"
   EndIf
   $i = 0
   $IncompProgLimit = 0
   FOR $element IN $IncompProg
      $i = $i + 1
      IF $element <> "" THEN
         $IncompProgLimit = $i
      ENDIF
   NEXT
   Global $cliplist[$LimitList+1][6]
   FOR $i = 0 To $LimitList-1
      $cliplist[$i][0] = ""
      $cliplist[$i][1] = ""
      $cliplist[$i][2] = ""
      $cliplist[$i][3] = ""
      $cliplist[$i][4] = "F"
      $cliplist[$i][5] = ""
   NEXT
	; It have to be set after all messages has been loaded
   _ScreenCapture_SetJPGQuality($iQuality)
   If $BgColorNormal = "" Then
      $BgColorNormal= "0xC7C7C7"
   EndIf
   If $BgColorInsert = "" Then
      $BgColorInsert= "0xFFFFF0"
   EndIf
	TrayItemSetText ( $stopdir ,show_mess(0,$DirName))
	TrayItemSetText ( $ManageDir ,show_mess(25,$DirName))	
	refresh_clips()
	If $ExitKey <> "" Then
      debug_write(0,@ScriptLineNumber&" - "&"Setting exit key:"&$ExitKey)
      HotKeySet($ExitKey,"Escape")
   EndIf
   set_keys()
EndFunc

Func set_about()
   Local $about, $i, $n
	$about = "Clipboard manager 6.07.008 (c) Richard Wiener, http://richard.wiener.sweb.cz/moje/SW/rclipstep.zip" & @LF
	$about =$about & "This program is FreeWare, based on AutoIt, inspired by Clipstep.ahk from Skrommel." & @LF & @LF
	$i = $maxmsg +1
	$n =  $maxclip +1
	While $i <=$maxmsg + $maxabout
      $about =$about & show_mess($i,$LimitList,$n) & @LF
      $i += 1		
	Wend
   return $about
EndFunc